** These are the 5,6,7 point {\cal Z} functions written in FORM notation
** (the 8pt functions are in a separate folder)

** ZZ() denote the {\cal Z} functions whose arguments are as follows:
** [c] denotes a comma
** [v] marks that the following arguments are vector indices
** [p] denotes a vertical bar | (the 'p' terminology is inspired from the "pipe" command in the UNIX shell)

** For example:
** ZZ(i1?,i2?,[c],i3?,[c],i4?,[c],i5?,[c],i6?,[v],m?) = {\cal Z}^m_{12,3,4,5,6}
** ZZ(i1?,i2?,[p],i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?) = {\cal Z}_{12|3,4,5,6,7}

** In addition:
** ellf(m) = \ell^m
** g1(i1,i2) = g^{(1)}_{12}
** g2(i1,i2) = g^{(2)}_{12}
** g3(i1,i2) = g^{(3)}_{12}
** g4(i1,i2) = g^{(4)}_{12}
** dg1(i1,i2) = \partial g^{(1)}_{12}
** dg2(i1,i2) = \partial g^{(2)}_{12}
** dg3(i1,i2) = \partial g^{(3)}_{12}
** d2g1(i1,i2) = \partial^2 g^{(1)}_{12}
** d2g2(i1,i2) = \partial^2 g^{(2)}_{12}
** d2g3(i1,i2) = \partial^2 g^{(3)}_{12}


*** 5pts
        id ZZ(i1?,[c],i2?,[c],i3?,[c],i4?,[c],i5?,[v],m?) = ellf(m);
        id ZZ(i1?,i2?,[c],i3?,[c],i4?,[c],i5?) = g1(i1,i2);

*** 6pts
        id ZZ(i1?,i2?,i3?,[c],i4?,[c],i5?,[c],i6?) =
        + g1(i1,i2)*g1(i2,i3)
        + g2(i1,i2)
        + g2(i2,i3)
        - g2(i1,i3)
        ;

        id ZZ(i1?,i2?,[c],i3?,i4?,[c],i5?,[c],i6?) =
        + g1(i1,i2)*g1(i3,i4)
        + g2(i1,i3)
        + g2(i2,i4)
        - g2(i1,i4)
        - g2(i2,i3)
        ;


        id ZZ(i1?,i2?,[c],i3?,[c],i4?,[c],i5?,[c],i6?,[v],m?) =
        + g1(i1,i2)*ellf(m)
          - kk(i1,m)*g2(i1,i2)
          + kk(i2,m)*g2(i1,i2)
          + kk(i3,m)*g2(i1,i3)
          - kk(i3,m)*g2(i2,i3)
          + kk(i4,m)*g2(i1,i4)
          - kk(i4,m)*g2(i2,i4)
          + kk(i5,m)*g2(i1,i5)
          - kk(i5,m)*g2(i2,i5)
          + kk(i6,m)*g2(i1,i6)
          - kk(i6,m)*g2(i2,i6)
        ;

        id ZZ(i1?,[c],i2?,[c],i3?,[c],i4?,[c],i5?,[c],i6?,[v],m?,n?) =
        + (
          + kk(i1,m)*kk(i2,n)*g2(i1,i2)
          + kk(i1,m)*kk(i3,n)*g2(i1,i3)
          + kk(i1,m)*kk(i4,n)*g2(i1,i4)
          + kk(i1,m)*kk(i5,n)*g2(i1,i5)
          + kk(i1,m)*kk(i6,n)*g2(i1,i6)
          + kk(i2,m)*kk(i3,n)*g2(i2,i3)
          + kk(i2,m)*kk(i4,n)*g2(i2,i4)
          + kk(i2,m)*kk(i5,n)*g2(i2,i5)
          + kk(i2,m)*kk(i6,n)*g2(i2,i6)
          + kk(i3,m)*kk(i4,n)*g2(i3,i4)
          + kk(i3,m)*kk(i5,n)*g2(i3,i5)
          + kk(i3,m)*kk(i6,n)*g2(i3,i6)
          + kk(i4,m)*kk(i5,n)*g2(i4,i5)
          + kk(i4,m)*kk(i6,n)*g2(i4,i6)
          + kk(i5,m)*kk(i6,n)*g2(i5,i6)
          )
          + (
          + kk(i1,n)*kk(i2,m)*g2(i1,i2)
          + kk(i1,n)*kk(i3,m)*g2(i1,i3)
          + kk(i1,n)*kk(i4,m)*g2(i1,i4)
          + kk(i1,n)*kk(i5,m)*g2(i1,i5)
          + kk(i1,n)*kk(i6,m)*g2(i1,i6)
          + kk(i2,n)*kk(i3,m)*g2(i2,i3)
          + kk(i2,n)*kk(i4,m)*g2(i2,i4)
          + kk(i2,n)*kk(i5,m)*g2(i2,i5)
          + kk(i2,n)*kk(i6,m)*g2(i2,i6)
          + kk(i3,n)*kk(i4,m)*g2(i3,i4)
          + kk(i3,n)*kk(i5,m)*g2(i3,i5)
          + kk(i3,n)*kk(i6,m)*g2(i3,i6)
          + kk(i4,n)*kk(i5,m)*g2(i4,i5)
          + kk(i4,n)*kk(i6,m)*g2(i4,i6)
          + kk(i5,n)*kk(i6,m)*g2(i5,i6)
          )
          + ellf(m)*ellf(n)
          ;


********** 7pts ********************
* 4,1,1,1
        id ZZ(i1?,i7?,i6?,i5?,[c],i2?,[c],i3?,[c],i4?) =
        + g1(i1,i6)*g2(i1,i5)
	- g1(i1,i6)*g2(i5,i6)
	+ g1(i1,i7)*g1(i5,i6)*g1(i6,i7)
	- g1(i1,i7)*g2(i1,i5)
	+ g1(i1,i7)*g2(i5,i6)
	+ g1(i1,i7)*g2(i6,i7)
	+ g1(i5,i6)*g2(i1,i6)
	- g1(i5,i6)*g2(i1,i7)
	- g1(i5,i6)*g2(i5,i7)
	+ g1(i6,i7)*g2(i1,i5)
	- g1(i6,i7)*g2(i1,i7)
	- g1(i6,i7)*g2(i5,i7)
	- g3(i1,i6)
	+ g3(i1,i7)
	+ g3(i5,i6)
	+ 2*g3(i5,i7)
        ;

* 3,2,1,1
        id ZZ(i2?,i3?,i4?,[c],i5?,i6?,[c],i7?,[c],i1?) =
        + g1(i2,i3)*g1(i3,i4)*g1(i5,i6)
          + g1(i2,i3)*g2(i2,i5)
          - g1(i2,i3)*g2(i2,i6)
          - g1(i2,i3)*g2(i4,i5)
          + g1(i2,i3)*g2(i4,i6)
          - g1(i2,i5)*g2(i2,i4)
          + g1(i2,i5)*g2(i4,i5)
          + g1(i2,i6)*g2(i2,i4)
          - g1(i2,i6)*g2(i4,i6)
          + g1(i3,i4)*g2(i2,i5)
          - g1(i3,i4)*g2(i2,i6)
          - g1(i3,i4)*g2(i3,i5)
          + g1(i3,i4)*g2(i3,i6)
          + g1(i3,i5)*g2(i3,i4)
          - g1(i3,i5)*g2(i4,i5)
          - g1(i3,i6)*g2(i3,i4)
          + g1(i3,i6)*g2(i4,i6)
          + g1(i5,i6)*g2(i2,i3)
          - g1(i5,i6)*g2(i2,i4)
          + g1(i5,i6)*g2(i3,i4)
          - g3(i2,i5)
          + g3(i2,i6)
          + g3(i3,i5)
          - g3(i3,i6)
          ;

* 2,2,2,1
          id ZZ(i1?,i2?,[c],i3?,i4?,[c],i5?,i6?,[c],i7?) =
          + g1(i1,i2)*g1(i3,i4)*g1(i5,i6)
          + g1(i1,i2)*g2(i3,i5)
          - g1(i1,i2)*g2(i3,i6)
          - g1(i1,i2)*g2(i4,i5)
          + g1(i1,i2)*g2(i4,i6)
          + g1(i1,i5)*g2(i1,i3)
          - g1(i1,i5)*g2(i1,i4)
          - g1(i1,i5)*g2(i3,i5)
          + g1(i1,i5)*g2(i4,i5)
          - g1(i1,i6)*g2(i1,i3)
          + g1(i1,i6)*g2(i1,i4)
          + g1(i1,i6)*g2(i3,i6)
          - g1(i1,i6)*g2(i4,i6)
          - g1(i2,i5)*g2(i2,i3)
          + g1(i2,i5)*g2(i2,i4)
          + g1(i2,i5)*g2(i3,i5)
          - g1(i2,i5)*g2(i4,i5)
          + g1(i2,i6)*g2(i2,i3)
          - g1(i2,i6)*g2(i2,i4)
          - g1(i2,i6)*g2(i3,i6)
          + g1(i2,i6)*g2(i4,i6)
          + g1(i3,i4)*g2(i1,i5)
          - g1(i3,i4)*g2(i1,i6)
          - g1(i3,i4)*g2(i2,i5)
          + g1(i3,i4)*g2(i2,i6)
          + g1(i5,i6)*g2(i1,i3)
          - g1(i5,i6)*g2(i1,i4)
          - g1(i5,i6)*g2(i2,i3)
          + g1(i5,i6)*g2(i2,i4)
          ;

          id ZZ(i2?,i3?,[c],i4?,i5?,[c],i1?,[c],i6?,[c],i7?,[v],m?) =
          + kk(i1,m)*g1(i1,i4)*g2(i1,i2)
          - kk(i1,m)*g1(i1,i4)*g2(i1,i3)
          - kk(i1,m)*g1(i1,i4)*g2(i2,i4)
          + kk(i1,m)*g1(i1,i4)*g2(i3,i4)
          - kk(i1,m)*g1(i1,i5)*g2(i1,i2)
          + kk(i1,m)*g1(i1,i5)*g2(i1,i3)
          + kk(i1,m)*g1(i1,i5)*g2(i2,i5)
          - kk(i1,m)*g1(i1,i5)*g2(i3,i5)
          + kk(i1,m)*g1(i2,i3)*g2(i1,i4)
          - kk(i1,m)*g1(i2,i3)*g2(i1,i5)
          + kk(i1,m)*g1(i4,i5)*g2(i1,i2)
          - kk(i1,m)*g1(i4,i5)*g2(i1,i3)
          + kk(i1,m)*g3(i2,i4)
          - kk(i1,m)*g3(i2,i5)
          - kk(i1,m)*g3(i3,i4)
          + kk(i1,m)*g3(i3,i5)
          + kk(i2,m)*g1(i2,i3)*g2(i2,i4)
          - kk(i2,m)*g1(i2,i3)*g2(i2,i5)
          - kk(i2,m)*g1(i2,i4)*g2(i2,i3)
          + kk(i2,m)*g1(i2,i4)*g2(i3,i4)
          + kk(i2,m)*g1(i2,i5)*g2(i2,i3)
          - kk(i2,m)*g1(i2,i5)*g2(i3,i5)
          - kk(i2,m)*g1(i4,i5)*g2(i2,i3)
          - 2*kk(i2,m)*g3(i2,i4)
          + 2*kk(i2,m)*g3(i2,i5)
          - kk(i2,m)*g3(i3,i4)
          + kk(i2,m)*g3(i3,i5)
          + kk(i3,m)*g1(i2,i3)*g2(i2,i4)
          - kk(i3,m)*g1(i2,i3)*g2(i2,i5)
          + kk(i3,m)*g1(i4,i5)*g2(i2,i3)
          - kk(i3,m)*g3(i2,i4)
          + kk(i3,m)*g3(i2,i5)
          + kk(i3,m)*g3(i3,i4)
          - kk(i3,m)*g3(i3,i5)
          - kk(i4,m)*g1(i2,i3)*g2(i4,i5)
          + kk(i4,m)*g1(i4,i5)*g2(i2,i5)
          - kk(i4,m)*g1(i4,i5)*g2(i3,i5)
          + kk(i4,m)*g3(i2,i4)
          - kk(i4,m)*g3(i2,i5)
          - kk(i4,m)*g3(i3,i4)
          + kk(i4,m)*g3(i3,i5)
          + kk(i5,m)*g1(i2,i3)*g2(i4,i5)
          + kk(i5,m)*g1(i2,i5)*g2(i2,i4)
          - kk(i5,m)*g1(i2,i5)*g2(i4,i5)
          - kk(i5,m)*g1(i3,i5)*g2(i3,i4)
          + kk(i5,m)*g1(i3,i5)*g2(i4,i5)
          + kk(i5,m)*g1(i4,i5)*g2(i2,i5)
          - kk(i5,m)*g1(i4,i5)*g2(i3,i5)
          - kk(i5,m)*g3(i2,i4)
          - 2*kk(i5,m)*g3(i2,i5)
          + kk(i5,m)*g3(i3,i4)
          + 2*kk(i5,m)*g3(i3,i5)
          + kk(i6,m)*g1(i2,i3)*g2(i4,i6)
          - kk(i6,m)*g1(i2,i3)*g2(i5,i6)
          + kk(i6,m)*g1(i2,i6)*g2(i2,i4)
          - kk(i6,m)*g1(i2,i6)*g2(i2,i5)
          - kk(i6,m)*g1(i2,i6)*g2(i4,i6)
          + kk(i6,m)*g1(i2,i6)*g2(i5,i6)
          - kk(i6,m)*g1(i3,i6)*g2(i3,i4)
          + kk(i6,m)*g1(i3,i6)*g2(i3,i5)
          + kk(i6,m)*g1(i3,i6)*g2(i4,i6)
          - kk(i6,m)*g1(i3,i6)*g2(i5,i6)
          + kk(i6,m)*g1(i4,i5)*g2(i2,i6)
          - kk(i6,m)*g1(i4,i5)*g2(i3,i6)
          - kk(i6,m)*g3(i2,i4)
          + kk(i6,m)*g3(i2,i5)
          + kk(i6,m)*g3(i3,i4)
          - kk(i6,m)*g3(i3,i5)
          + kk(i7,m)*g1(i2,i3)*g2(i4,i7)
          - kk(i7,m)*g1(i2,i3)*g2(i5,i7)
          + kk(i7,m)*g1(i2,i7)*g2(i2,i4)
          - kk(i7,m)*g1(i2,i7)*g2(i2,i5)
          - kk(i7,m)*g1(i2,i7)*g2(i4,i7)
          + kk(i7,m)*g1(i2,i7)*g2(i5,i7)
          - kk(i7,m)*g1(i3,i7)*g2(i3,i4)
          + kk(i7,m)*g1(i3,i7)*g2(i3,i5)
          + kk(i7,m)*g1(i3,i7)*g2(i4,i7)
          - kk(i7,m)*g1(i3,i7)*g2(i5,i7)
          + kk(i7,m)*g1(i4,i5)*g2(i2,i7)
          - kk(i7,m)*g1(i4,i5)*g2(i3,i7)
          - kk(i7,m)*g3(i2,i4)
          + kk(i7,m)*g3(i2,i5)
          + kk(i7,m)*g3(i3,i4)
          - kk(i7,m)*g3(i3,i5)
          + g1(i2,i3)*g1(i4,i5)*ellf(m)
          + g2(i2,i4)*ellf(m)
          - g2(i2,i5)*ellf(m)
          - g2(i3,i4)*ellf(m)
          + g2(i3,i5)*ellf(m)
          ;

          id ZZ(i1?,i2?,i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?,[v],m?) =
          - kk(i1,m)*g1(i1,i2)*g2(i1,i3)
          - kk(i1,m)*g1(i2,i3)*g2(i1,i3)
          + 3*kk(i1,m)*g3(i1,i3)
          - kk(i2,m)*g1(i1,i2)*g2(i1,i3)
          + kk(i2,m)*g1(i1,i3)*g2(i1,i2)
          - kk(i2,m)*g1(i1,i3)*g2(i2,i3)
          + kk(i2,m)*g1(i2,i3)*g2(i1,i3)
          + kk(i3,m)*g1(i1,i2)*g2(i1,i3)
          + kk(i3,m)*g1(i2,i3)*g2(i1,i3)
          - 3*kk(i3,m)*g3(i1,i3)
          + kk(i4,m)*g1(i1,i2)*g2(i1,i4)
          - kk(i4,m)*g1(i1,i2)*g2(i3,i4)
          - kk(i4,m)*g1(i1,i4)*g2(i1,i3)
          + kk(i4,m)*g1(i1,i4)*g2(i3,i4)
          + kk(i4,m)*g1(i2,i3)*g2(i1,i4)
          - kk(i4,m)*g1(i2,i3)*g2(i2,i4)
          + kk(i4,m)*g1(i2,i4)*g2(i2,i3)
          - kk(i4,m)*g1(i2,i4)*g2(i3,i4)
          + kk(i4,m)*g3(i1,i3)
          - kk(i4,m)*g3(i1,i4)
          - kk(i4,m)*g3(i2,i3)
          + kk(i4,m)*g3(i2,i4)
          + kk(i5,m)*g1(i1,i2)*g2(i1,i5)
          - kk(i5,m)*g1(i1,i2)*g2(i3,i5)
          - kk(i5,m)*g1(i1,i5)*g2(i1,i3)
          + kk(i5,m)*g1(i1,i5)*g2(i3,i5)
          + kk(i5,m)*g1(i2,i3)*g2(i1,i5)
          - kk(i5,m)*g1(i2,i3)*g2(i2,i5)
          + kk(i5,m)*g1(i2,i5)*g2(i2,i3)
          - kk(i5,m)*g1(i2,i5)*g2(i3,i5)
          + kk(i5,m)*g3(i1,i3)
          - kk(i5,m)*g3(i1,i5)
          - kk(i5,m)*g3(i2,i3)
          + kk(i5,m)*g3(i2,i5)
          + kk(i6,m)*g1(i1,i2)*g2(i1,i6)
          - kk(i6,m)*g1(i1,i2)*g2(i3,i6)
          - kk(i6,m)*g1(i1,i6)*g2(i1,i3)
          + kk(i6,m)*g1(i1,i6)*g2(i3,i6)
          + kk(i6,m)*g1(i2,i3)*g2(i1,i6)
          - kk(i6,m)*g1(i2,i3)*g2(i2,i6)
          + kk(i6,m)*g1(i2,i6)*g2(i2,i3)
          - kk(i6,m)*g1(i2,i6)*g2(i3,i6)
          + kk(i6,m)*g3(i1,i3)
          - kk(i6,m)*g3(i1,i6)
          - kk(i6,m)*g3(i2,i3)
          + kk(i6,m)*g3(i2,i6)
          + kk(i7,m)*g1(i1,i2)*g2(i1,i7)
          - kk(i7,m)*g1(i1,i2)*g2(i3,i7)
          - kk(i7,m)*g1(i1,i7)*g2(i1,i3)
          + kk(i7,m)*g1(i1,i7)*g2(i3,i7)
          + kk(i7,m)*g1(i2,i3)*g2(i1,i7)
          - kk(i7,m)*g1(i2,i3)*g2(i2,i7)
          + kk(i7,m)*g1(i2,i7)*g2(i2,i3)
          - kk(i7,m)*g1(i2,i7)*g2(i3,i7)
          + kk(i7,m)*g3(i1,i3)
          - kk(i7,m)*g3(i1,i7)
          - kk(i7,m)*g3(i2,i3)
          + kk(i7,m)*g3(i2,i7)
          + g1(i1,i2)*g1(i2,i3)*ellf(m)
          + g2(i1,i2)*ellf(m)
          - g2(i1,i3)*ellf(m)
          + g2(i2,i3)*ellf(m)
          ;

	id ZZ(i2?,i3?,[c],i1?,[c],i4?,[c],i5?,[c],i6?,[c],i7?,[v],m?,n?) =
	+ (
	- kk(i1,m)*kk(i1,n)*g3(i1,i2)
	+ kk(i1,m)*kk(i1,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i2,n)*g1(i2,i3)*g2(i1,i3)
	+ kk(i1,m)*kk(i2,n)*g3(i1,i2)
	- kk(i1,m)*kk(i2,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i3,n)*g1(i1,i3)*g2(i1,i2)
	- kk(i1,m)*kk(i3,n)*g1(i1,i3)*g2(i2,i3)
	+ kk(i1,m)*kk(i3,n)*g1(i2,i3)*g2(i1,i3)
	- kk(i1,m)*kk(i3,n)*g3(i1,i2)
	- 2*kk(i1,m)*kk(i3,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i3,n)*g3(i2,i3)
	+ kk(i1,m)*kk(i4,n)*g1(i1,i4)*g2(i1,i2)
	- kk(i1,m)*kk(i4,n)*g1(i1,i4)*g2(i1,i3)
	- kk(i1,m)*kk(i4,n)*g1(i1,i4)*g2(i2,i4)
	+ kk(i1,m)*kk(i4,n)*g1(i1,i4)*g2(i3,i4)
	+ kk(i1,m)*kk(i4,n)*g1(i2,i3)*g2(i1,i4)
	- kk(i1,m)*kk(i4,n)*g3(i1,i2)
	+ kk(i1,m)*kk(i4,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i4,n)*g3(i2,i4)
	- kk(i1,m)*kk(i4,n)*g3(i3,i4)
	+ kk(i1,m)*kk(i5,n)*g1(i1,i5)*g2(i1,i2)
	- kk(i1,m)*kk(i5,n)*g1(i1,i5)*g2(i1,i3)
	- kk(i1,m)*kk(i5,n)*g1(i1,i5)*g2(i2,i5)
	+ kk(i1,m)*kk(i5,n)*g1(i1,i5)*g2(i3,i5)
	+ kk(i1,m)*kk(i5,n)*g1(i2,i3)*g2(i1,i5)
	- kk(i1,m)*kk(i5,n)*g3(i1,i2)
	+ kk(i1,m)*kk(i5,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i5,n)*g3(i2,i5)
	- kk(i1,m)*kk(i5,n)*g3(i3,i5)
	+ kk(i1,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i2)
	- kk(i1,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i3)
	- kk(i1,m)*kk(i6,n)*g1(i1,i6)*g2(i2,i6)
	+ kk(i1,m)*kk(i6,n)*g1(i1,i6)*g2(i3,i6)
	+ kk(i1,m)*kk(i6,n)*g1(i2,i3)*g2(i1,i6)
	- kk(i1,m)*kk(i6,n)*g3(i1,i2)
	+ kk(i1,m)*kk(i6,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i6,n)*g3(i2,i6)
	- kk(i1,m)*kk(i6,n)*g3(i3,i6)
	+ kk(i1,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i2)
	- kk(i1,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i3)
	- kk(i1,m)*kk(i7,n)*g1(i1,i7)*g2(i2,i7)
	+ kk(i1,m)*kk(i7,n)*g1(i1,i7)*g2(i3,i7)
	+ kk(i1,m)*kk(i7,n)*g1(i2,i3)*g2(i1,i7)
	- kk(i1,m)*kk(i7,n)*g3(i1,i2)
	+ kk(i1,m)*kk(i7,n)*g3(i1,i3)
	+ kk(i1,m)*kk(i7,n)*g3(i2,i7)
	- kk(i1,m)*kk(i7,n)*g3(i3,i7)
	+ kk(i1,m)*g2(i1,i2)*ellf(n)
	- kk(i1,m)*g2(i1,i3)*ellf(n)
	+ kk(i2,m)*kk(i2,n)*g3(i2,i3)
	- kk(i2,m)*kk(i3,n)*g3(i2,i3)
	+ kk(i2,m)*kk(i4,n)*g1(i2,i3)*g2(i2,i4)
	- kk(i2,m)*kk(i4,n)*g1(i2,i4)*g2(i2,i3)
	+ kk(i2,m)*kk(i4,n)*g1(i2,i4)*g2(i3,i4)
	+ kk(i2,m)*kk(i4,n)*g3(i2,i3)
	- 2*kk(i2,m)*kk(i4,n)*g3(i2,i4)
	- kk(i2,m)*kk(i4,n)*g3(i3,i4)
	+ kk(i2,m)*kk(i5,n)*g1(i2,i3)*g2(i2,i5)
	- kk(i2,m)*kk(i5,n)*g1(i2,i5)*g2(i2,i3)
	+ kk(i2,m)*kk(i5,n)*g1(i2,i5)*g2(i3,i5)
	+ kk(i2,m)*kk(i5,n)*g3(i2,i3)
	- 2*kk(i2,m)*kk(i5,n)*g3(i2,i5)
	- kk(i2,m)*kk(i5,n)*g3(i3,i5)
	+ kk(i2,m)*kk(i6,n)*g1(i2,i3)*g2(i2,i6)
	- kk(i2,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i3)
	+ kk(i2,m)*kk(i6,n)*g1(i2,i6)*g2(i3,i6)
	+ kk(i2,m)*kk(i6,n)*g3(i2,i3)
	- 2*kk(i2,m)*kk(i6,n)*g3(i2,i6)
	- kk(i2,m)*kk(i6,n)*g3(i3,i6)
	+ kk(i2,m)*kk(i7,n)*g1(i2,i3)*g2(i2,i7)
	- kk(i2,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i3)
	+ kk(i2,m)*kk(i7,n)*g1(i2,i7)*g2(i3,i7)
	+ kk(i2,m)*kk(i7,n)*g3(i2,i3)
	- 2*kk(i2,m)*kk(i7,n)*g3(i2,i7)
	- kk(i2,m)*kk(i7,n)*g3(i3,i7)
	- kk(i2,m)*g2(i2,i3)*ellf(n)
	+ kk(i3,m)*kk(i3,n)*g3(i2,i3)
	+ kk(i3,m)*kk(i4,n)*g1(i2,i3)*g2(i2,i4)
	- kk(i3,m)*kk(i4,n)*g3(i2,i4)
	+ kk(i3,m)*kk(i4,n)*g3(i3,i4)
	+ kk(i3,m)*kk(i5,n)*g1(i2,i3)*g2(i2,i5)
	- kk(i3,m)*kk(i5,n)*g3(i2,i5)
	+ kk(i3,m)*kk(i5,n)*g3(i3,i5)
	+ kk(i3,m)*kk(i6,n)*g1(i2,i3)*g2(i2,i6)
	- kk(i3,m)*kk(i6,n)*g3(i2,i6)
	+ kk(i3,m)*kk(i6,n)*g3(i3,i6)
	+ kk(i3,m)*kk(i7,n)*g1(i2,i3)*g2(i2,i7)
	- kk(i3,m)*kk(i7,n)*g3(i2,i7)
	+ kk(i3,m)*kk(i7,n)*g3(i3,i7)
	+ kk(i3,m)*g2(i2,i3)*ellf(n)
	+ kk(i4,m)*kk(i4,n)*g3(i2,i4)
	- kk(i4,m)*kk(i4,n)*g3(i3,i4)
	+ kk(i4,m)*kk(i5,n)*g1(i2,i3)*g2(i4,i5)
	+ kk(i4,m)*kk(i5,n)*g1(i2,i5)*g2(i2,i4)
	- kk(i4,m)*kk(i5,n)*g1(i2,i5)*g2(i4,i5)
	- kk(i4,m)*kk(i5,n)*g1(i3,i5)*g2(i3,i4)
	+ kk(i4,m)*kk(i5,n)*g1(i3,i5)*g2(i4,i5)
	- kk(i4,m)*kk(i5,n)*g3(i2,i4)
	+ kk(i4,m)*kk(i5,n)*g3(i3,i4)
	+ kk(i4,m)*kk(i6,n)*g1(i2,i3)*g2(i4,i6)
	+ kk(i4,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i4)
	- kk(i4,m)*kk(i6,n)*g1(i2,i6)*g2(i4,i6)
	- kk(i4,m)*kk(i6,n)*g1(i3,i6)*g2(i3,i4)
	+ kk(i4,m)*kk(i6,n)*g1(i3,i6)*g2(i4,i6)
	- kk(i4,m)*kk(i6,n)*g3(i2,i4)
	+ kk(i4,m)*kk(i6,n)*g3(i3,i4)
	+ kk(i4,m)*kk(i7,n)*g1(i2,i3)*g2(i4,i7)
	+ kk(i4,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i4)
	- kk(i4,m)*kk(i7,n)*g1(i2,i7)*g2(i4,i7)
	- kk(i4,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i4)
	+ kk(i4,m)*kk(i7,n)*g1(i3,i7)*g2(i4,i7)
	- kk(i4,m)*kk(i7,n)*g3(i2,i4)
	+ kk(i4,m)*kk(i7,n)*g3(i3,i4)
	+ kk(i4,m)*g2(i2,i4)*ellf(n)
	- kk(i4,m)*g2(i3,i4)*ellf(n)
	+ kk(i5,m)*kk(i5,n)*g3(i2,i5)
	- kk(i5,m)*kk(i5,n)*g3(i3,i5)
	+ kk(i5,m)*kk(i6,n)*g1(i2,i3)*g2(i5,i6)
	+ kk(i5,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i5)
	- kk(i5,m)*kk(i6,n)*g1(i2,i6)*g2(i5,i6)
	- kk(i5,m)*kk(i6,n)*g1(i3,i6)*g2(i3,i5)
	+ kk(i5,m)*kk(i6,n)*g1(i3,i6)*g2(i5,i6)
	- kk(i5,m)*kk(i6,n)*g3(i2,i5)
	+ kk(i5,m)*kk(i6,n)*g3(i3,i5)
	+ kk(i5,m)*kk(i7,n)*g1(i2,i3)*g2(i5,i7)
	+ kk(i5,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i5)
	- kk(i5,m)*kk(i7,n)*g1(i2,i7)*g2(i5,i7)
	- kk(i5,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i5)
	+ kk(i5,m)*kk(i7,n)*g1(i3,i7)*g2(i5,i7)
	- kk(i5,m)*kk(i7,n)*g3(i2,i5)
	+ kk(i5,m)*kk(i7,n)*g3(i3,i5)
	+ kk(i5,m)*g2(i2,i5)*ellf(n)
	- kk(i5,m)*g2(i3,i5)*ellf(n)
	+ kk(i6,m)*kk(i6,n)*g3(i2,i6)
	- kk(i6,m)*kk(i6,n)*g3(i3,i6)
	+ kk(i6,m)*kk(i7,n)*g1(i2,i3)*g2(i6,i7)
	+ kk(i6,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i6)
	- kk(i6,m)*kk(i7,n)*g1(i2,i7)*g2(i6,i7)
	- kk(i6,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i6)
	+ kk(i6,m)*kk(i7,n)*g1(i3,i7)*g2(i6,i7)
	- kk(i6,m)*kk(i7,n)*g3(i2,i6)
	+ kk(i6,m)*kk(i7,n)*g3(i3,i6)
	+ kk(i6,m)*g2(i2,i6)*ellf(n)
	- kk(i6,m)*g2(i3,i6)*ellf(n)
	+ kk(i7,m)*kk(i7,n)*g3(i2,i7)
	- kk(i7,m)*kk(i7,n)*g3(i3,i7)
	+ kk(i7,m)*g2(i2,i7)*ellf(n)
	- kk(i7,m)*g2(i3,i7)*ellf(n)
* symmetrize in mn
	- kk(i1,n)*kk(i1,m)*g3(i1,i2)
	+ kk(i1,n)*kk(i1,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i2,m)*g1(i2,i3)*g2(i1,i3)
	+ kk(i1,n)*kk(i2,m)*g3(i1,i2)
	- kk(i1,n)*kk(i2,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i3,m)*g1(i1,i3)*g2(i1,i2)
	- kk(i1,n)*kk(i3,m)*g1(i1,i3)*g2(i2,i3)
	+ kk(i1,n)*kk(i3,m)*g1(i2,i3)*g2(i1,i3)
	- kk(i1,n)*kk(i3,m)*g3(i1,i2)
	- 2*kk(i1,n)*kk(i3,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i3,m)*g3(i2,i3)
	+ kk(i1,n)*kk(i4,m)*g1(i1,i4)*g2(i1,i2)
	- kk(i1,n)*kk(i4,m)*g1(i1,i4)*g2(i1,i3)
	- kk(i1,n)*kk(i4,m)*g1(i1,i4)*g2(i2,i4)
	+ kk(i1,n)*kk(i4,m)*g1(i1,i4)*g2(i3,i4)
	+ kk(i1,n)*kk(i4,m)*g1(i2,i3)*g2(i1,i4)
	- kk(i1,n)*kk(i4,m)*g3(i1,i2)
	+ kk(i1,n)*kk(i4,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i4,m)*g3(i2,i4)
	- kk(i1,n)*kk(i4,m)*g3(i3,i4)
	+ kk(i1,n)*kk(i5,m)*g1(i1,i5)*g2(i1,i2)
	- kk(i1,n)*kk(i5,m)*g1(i1,i5)*g2(i1,i3)
	- kk(i1,n)*kk(i5,m)*g1(i1,i5)*g2(i2,i5)
	+ kk(i1,n)*kk(i5,m)*g1(i1,i5)*g2(i3,i5)
	+ kk(i1,n)*kk(i5,m)*g1(i2,i3)*g2(i1,i5)
	- kk(i1,n)*kk(i5,m)*g3(i1,i2)
	+ kk(i1,n)*kk(i5,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i5,m)*g3(i2,i5)
	- kk(i1,n)*kk(i5,m)*g3(i3,i5)
	+ kk(i1,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i2)
	- kk(i1,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i3)
	- kk(i1,n)*kk(i6,m)*g1(i1,i6)*g2(i2,i6)
	+ kk(i1,n)*kk(i6,m)*g1(i1,i6)*g2(i3,i6)
	+ kk(i1,n)*kk(i6,m)*g1(i2,i3)*g2(i1,i6)
	- kk(i1,n)*kk(i6,m)*g3(i1,i2)
	+ kk(i1,n)*kk(i6,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i6,m)*g3(i2,i6)
	- kk(i1,n)*kk(i6,m)*g3(i3,i6)
	+ kk(i1,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i2)
	- kk(i1,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i3)
	- kk(i1,n)*kk(i7,m)*g1(i1,i7)*g2(i2,i7)
	+ kk(i1,n)*kk(i7,m)*g1(i1,i7)*g2(i3,i7)
	+ kk(i1,n)*kk(i7,m)*g1(i2,i3)*g2(i1,i7)
	- kk(i1,n)*kk(i7,m)*g3(i1,i2)
	+ kk(i1,n)*kk(i7,m)*g3(i1,i3)
	+ kk(i1,n)*kk(i7,m)*g3(i2,i7)
	- kk(i1,n)*kk(i7,m)*g3(i3,i7)
	+ kk(i1,n)*g2(i1,i2)*ellf(m)
	- kk(i1,n)*g2(i1,i3)*ellf(m)
	+ kk(i2,n)*kk(i2,m)*g3(i2,i3)
	- kk(i2,n)*kk(i3,m)*g3(i2,i3)
	+ kk(i2,n)*kk(i4,m)*g1(i2,i3)*g2(i2,i4)
	- kk(i2,n)*kk(i4,m)*g1(i2,i4)*g2(i2,i3)
	+ kk(i2,n)*kk(i4,m)*g1(i2,i4)*g2(i3,i4)
	+ kk(i2,n)*kk(i4,m)*g3(i2,i3)
	- 2*kk(i2,n)*kk(i4,m)*g3(i2,i4)
	- kk(i2,n)*kk(i4,m)*g3(i3,i4)
	+ kk(i2,n)*kk(i5,m)*g1(i2,i3)*g2(i2,i5)
	- kk(i2,n)*kk(i5,m)*g1(i2,i5)*g2(i2,i3)
	+ kk(i2,n)*kk(i5,m)*g1(i2,i5)*g2(i3,i5)
	+ kk(i2,n)*kk(i5,m)*g3(i2,i3)
	- 2*kk(i2,n)*kk(i5,m)*g3(i2,i5)
	- kk(i2,n)*kk(i5,m)*g3(i3,i5)
	+ kk(i2,n)*kk(i6,m)*g1(i2,i3)*g2(i2,i6)
	- kk(i2,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i3)
	+ kk(i2,n)*kk(i6,m)*g1(i2,i6)*g2(i3,i6)
	+ kk(i2,n)*kk(i6,m)*g3(i2,i3)
	- 2*kk(i2,n)*kk(i6,m)*g3(i2,i6)
	- kk(i2,n)*kk(i6,m)*g3(i3,i6)
	+ kk(i2,n)*kk(i7,m)*g1(i2,i3)*g2(i2,i7)
	- kk(i2,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i3)
	+ kk(i2,n)*kk(i7,m)*g1(i2,i7)*g2(i3,i7)
	+ kk(i2,n)*kk(i7,m)*g3(i2,i3)
	- 2*kk(i2,n)*kk(i7,m)*g3(i2,i7)
	- kk(i2,n)*kk(i7,m)*g3(i3,i7)
	- kk(i2,n)*g2(i2,i3)*ellf(m)
	+ kk(i3,n)*kk(i3,m)*g3(i2,i3)
	+ kk(i3,n)*kk(i4,m)*g1(i2,i3)*g2(i2,i4)
	- kk(i3,n)*kk(i4,m)*g3(i2,i4)
	+ kk(i3,n)*kk(i4,m)*g3(i3,i4)
	+ kk(i3,n)*kk(i5,m)*g1(i2,i3)*g2(i2,i5)
	- kk(i3,n)*kk(i5,m)*g3(i2,i5)
	+ kk(i3,n)*kk(i5,m)*g3(i3,i5)
	+ kk(i3,n)*kk(i6,m)*g1(i2,i3)*g2(i2,i6)
	- kk(i3,n)*kk(i6,m)*g3(i2,i6)
	+ kk(i3,n)*kk(i6,m)*g3(i3,i6)
	+ kk(i3,n)*kk(i7,m)*g1(i2,i3)*g2(i2,i7)
	- kk(i3,n)*kk(i7,m)*g3(i2,i7)
	+ kk(i3,n)*kk(i7,m)*g3(i3,i7)
	+ kk(i3,n)*g2(i2,i3)*ellf(m)
	+ kk(i4,n)*kk(i4,m)*g3(i2,i4)
	- kk(i4,n)*kk(i4,m)*g3(i3,i4)
	+ kk(i4,n)*kk(i5,m)*g1(i2,i3)*g2(i4,i5)
	+ kk(i4,n)*kk(i5,m)*g1(i2,i5)*g2(i2,i4)
	- kk(i4,n)*kk(i5,m)*g1(i2,i5)*g2(i4,i5)
	- kk(i4,n)*kk(i5,m)*g1(i3,i5)*g2(i3,i4)
	+ kk(i4,n)*kk(i5,m)*g1(i3,i5)*g2(i4,i5)
	- kk(i4,n)*kk(i5,m)*g3(i2,i4)
	+ kk(i4,n)*kk(i5,m)*g3(i3,i4)
	+ kk(i4,n)*kk(i6,m)*g1(i2,i3)*g2(i4,i6)
	+ kk(i4,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i4)
	- kk(i4,n)*kk(i6,m)*g1(i2,i6)*g2(i4,i6)
	- kk(i4,n)*kk(i6,m)*g1(i3,i6)*g2(i3,i4)
	+ kk(i4,n)*kk(i6,m)*g1(i3,i6)*g2(i4,i6)
	- kk(i4,n)*kk(i6,m)*g3(i2,i4)
	+ kk(i4,n)*kk(i6,m)*g3(i3,i4)
	+ kk(i4,n)*kk(i7,m)*g1(i2,i3)*g2(i4,i7)
	+ kk(i4,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i4)
	- kk(i4,n)*kk(i7,m)*g1(i2,i7)*g2(i4,i7)
	- kk(i4,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i4)
	+ kk(i4,n)*kk(i7,m)*g1(i3,i7)*g2(i4,i7)
	- kk(i4,n)*kk(i7,m)*g3(i2,i4)
	+ kk(i4,n)*kk(i7,m)*g3(i3,i4)
	+ kk(i4,n)*g2(i2,i4)*ellf(m)
	- kk(i4,n)*g2(i3,i4)*ellf(m)
	+ kk(i5,n)*kk(i5,m)*g3(i2,i5)
	- kk(i5,n)*kk(i5,m)*g3(i3,i5)
	+ kk(i5,n)*kk(i6,m)*g1(i2,i3)*g2(i5,i6)
	+ kk(i5,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i5)
	- kk(i5,n)*kk(i6,m)*g1(i2,i6)*g2(i5,i6)
	- kk(i5,n)*kk(i6,m)*g1(i3,i6)*g2(i3,i5)
	+ kk(i5,n)*kk(i6,m)*g1(i3,i6)*g2(i5,i6)
	- kk(i5,n)*kk(i6,m)*g3(i2,i5)
	+ kk(i5,n)*kk(i6,m)*g3(i3,i5)
	+ kk(i5,n)*kk(i7,m)*g1(i2,i3)*g2(i5,i7)
	+ kk(i5,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i5)
	- kk(i5,n)*kk(i7,m)*g1(i2,i7)*g2(i5,i7)
	- kk(i5,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i5)
	+ kk(i5,n)*kk(i7,m)*g1(i3,i7)*g2(i5,i7)
	- kk(i5,n)*kk(i7,m)*g3(i2,i5)
	+ kk(i5,n)*kk(i7,m)*g3(i3,i5)
	+ kk(i5,n)*g2(i2,i5)*ellf(m)
	- kk(i5,n)*g2(i3,i5)*ellf(m)
	+ kk(i6,n)*kk(i6,m)*g3(i2,i6)
	- kk(i6,n)*kk(i6,m)*g3(i3,i6)
	+ kk(i6,n)*kk(i7,m)*g1(i2,i3)*g2(i6,i7)
	+ kk(i6,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i6)
	- kk(i6,n)*kk(i7,m)*g1(i2,i7)*g2(i6,i7)
	- kk(i6,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i6)
	+ kk(i6,n)*kk(i7,m)*g1(i3,i7)*g2(i6,i7)
	- kk(i6,n)*kk(i7,m)*g3(i2,i6)
	+ kk(i6,n)*kk(i7,m)*g3(i3,i6)
	+ kk(i6,n)*g2(i2,i6)*ellf(m)
	- kk(i6,n)*g2(i3,i6)*ellf(m)
	+ kk(i7,n)*kk(i7,m)*g3(i2,i7)
	- kk(i7,n)*kk(i7,m)*g3(i3,i7)
	+ kk(i7,n)*g2(i2,i7)*ellf(m)
	- kk(i7,n)*g2(i3,i7)*ellf(m)
	)
	+ g1(i2,i3)*ellf(m)*ellf(n)
	;


        id ZZ(i1?,[c],i2?,[c],i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?,[v],m?,n?,p?) =
        + ellf(m)*ellf(n)*ellf(p)
        - kk(i1,m)*kk(i1,n)*kk(i2,p)*g3(i1,i2)
       - kk(i1,m)*kk(i1,p)*kk(i2,n)*g3(i1,i2)
       - kk(i1,p)*kk(i1,m)*kk(i2,n)*g3(i1,i2)
       - kk(i1,p)*kk(i1,n)*kk(i2,m)*g3(i1,i2)
       - kk(i1,n)*kk(i1,p)*kk(i2,m)*g3(i1,i2)
       - kk(i1,n)*kk(i1,m)*kk(i2,p)*g3(i1,i2)
       - kk(i1,n)*kk(i1,m)*kk(i3,p)*g3(i1,i3)
       - kk(i1,n)*kk(i1,p)*kk(i3,m)*g3(i1,i3)
       - kk(i1,p)*kk(i1,n)*kk(i3,m)*g3(i1,i3)
       - kk(i1,p)*kk(i1,m)*kk(i3,n)*g3(i1,i3)
       - kk(i1,m)*kk(i1,p)*kk(i3,n)*g3(i1,i3)
       - kk(i1,m)*kk(i1,n)*kk(i3,p)*g3(i1,i3)
       - kk(i1,m)*kk(i1,n)*kk(i4,p)*g3(i1,i4)
       - kk(i1,m)*kk(i1,p)*kk(i4,n)*g3(i1,i4)
       - kk(i1,p)*kk(i1,m)*kk(i4,n)*g3(i1,i4)
       - kk(i1,p)*kk(i1,n)*kk(i4,m)*g3(i1,i4)
       - kk(i1,n)*kk(i1,p)*kk(i4,m)*g3(i1,i4)
       - kk(i1,n)*kk(i1,m)*kk(i4,p)*g3(i1,i4)
       - kk(i1,n)*kk(i1,m)*kk(i5,p)*g3(i1,i5)
       - kk(i1,n)*kk(i1,p)*kk(i5,m)*g3(i1,i5)
       - kk(i1,p)*kk(i1,n)*kk(i5,m)*g3(i1,i5)
       - kk(i1,p)*kk(i1,m)*kk(i5,n)*g3(i1,i5)
       - kk(i1,m)*kk(i1,p)*kk(i5,n)*g3(i1,i5)
       - kk(i1,m)*kk(i1,n)*kk(i5,p)*g3(i1,i5)
       - kk(i1,m)*kk(i1,n)*kk(i6,p)*g3(i1,i6)
       - kk(i1,m)*kk(i1,p)*kk(i6,n)*g3(i1,i6)
       - kk(i1,p)*kk(i1,m)*kk(i6,n)*g3(i1,i6)
       - kk(i1,p)*kk(i1,n)*kk(i6,m)*g3(i1,i6)
       - kk(i1,n)*kk(i1,p)*kk(i6,m)*g3(i1,i6)
       - kk(i1,n)*kk(i1,m)*kk(i6,p)*g3(i1,i6)
       - kk(i1,n)*kk(i1,m)*kk(i7,p)*g3(i1,i7)
       - kk(i1,n)*kk(i1,p)*kk(i7,m)*g3(i1,i7)
       - kk(i1,p)*kk(i1,n)*kk(i7,m)*g3(i1,i7)
       - kk(i1,p)*kk(i1,m)*kk(i7,n)*g3(i1,i7)
       - kk(i1,m)*kk(i1,p)*kk(i7,n)*g3(i1,i7)
       - kk(i1,m)*kk(i1,n)*kk(i7,p)*g3(i1,i7)
       + kk(i1,m)*kk(i2,n)*kk(i2,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i2,n)*g3(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i2,n)*g3(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i2,m)*g3(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i2,m)*g3(i1,i2)
       + kk(i1,n)*kk(i2,m)*kk(i2,p)*g3(i1,i2)
       + kk(i1,n)*kk(i2,m)*kk(i3,p)*g1(i1,i3)*g2(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i3,m)*g1(i1,i3)*g2(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i3,m)*g1(i1,i3)*g2(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i3,n)*g1(i1,i3)*g2(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i3,n)*g1(i1,i3)*g2(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i3,p)*g1(i1,i3)*g2(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i3,p)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,m)*kk(i2,p)*kk(i3,n)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,p)*kk(i2,m)*kk(i3,n)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,p)*kk(i2,n)*kk(i3,m)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,n)*kk(i2,p)*kk(i3,m)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,n)*kk(i2,m)*kk(i3,p)*g1(i1,i3)*g2(i2,i3)
       - kk(i1,n)*kk(i2,m)*kk(i3,p)*g3(i1,i2)
       - kk(i1,n)*kk(i2,p)*kk(i3,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,n)*kk(i3,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,m)*kk(i3,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,p)*kk(i3,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i3,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i3,p)*g3(i2,i3)
       + kk(i1,m)*kk(i2,p)*kk(i3,n)*g3(i2,i3)
       + kk(i1,p)*kk(i2,m)*kk(i3,n)*g3(i2,i3)
       + kk(i1,p)*kk(i2,n)*kk(i3,m)*g3(i2,i3)
       + kk(i1,n)*kk(i2,p)*kk(i3,m)*g3(i2,i3)
       + kk(i1,n)*kk(i2,m)*kk(i3,p)*g3(i2,i3)
       + kk(i1,n)*kk(i2,m)*kk(i4,p)*g1(i1,i4)*g2(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i4,m)*g1(i1,i4)*g2(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i4,m)*g1(i1,i4)*g2(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i4,n)*g1(i1,i4)*g2(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i4,n)*g1(i1,i4)*g2(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i4,p)*g1(i1,i4)*g2(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i4,p)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,m)*kk(i2,p)*kk(i4,n)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,p)*kk(i2,m)*kk(i4,n)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,p)*kk(i2,n)*kk(i4,m)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,n)*kk(i2,p)*kk(i4,m)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,n)*kk(i2,m)*kk(i4,p)*g1(i1,i4)*g2(i2,i4)
       - kk(i1,n)*kk(i2,m)*kk(i4,p)*g3(i1,i2)
       - kk(i1,n)*kk(i2,p)*kk(i4,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,n)*kk(i4,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,m)*kk(i4,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,p)*kk(i4,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i4,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i4,p)*g3(i2,i4)
       + kk(i1,m)*kk(i2,p)*kk(i4,n)*g3(i2,i4)
       + kk(i1,p)*kk(i2,m)*kk(i4,n)*g3(i2,i4)
       + kk(i1,p)*kk(i2,n)*kk(i4,m)*g3(i2,i4)
       + kk(i1,n)*kk(i2,p)*kk(i4,m)*g3(i2,i4)
       + kk(i1,n)*kk(i2,m)*kk(i4,p)*g3(i2,i4)
       + kk(i1,n)*kk(i2,m)*kk(i5,p)*g1(i1,i5)*g2(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i5,m)*g1(i1,i5)*g2(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i5,m)*g1(i1,i5)*g2(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i5,n)*g1(i1,i5)*g2(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i5,n)*g1(i1,i5)*g2(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i5,p)*g1(i1,i5)*g2(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i5,p)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,m)*kk(i2,p)*kk(i5,n)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,p)*kk(i2,m)*kk(i5,n)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,p)*kk(i2,n)*kk(i5,m)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,n)*kk(i2,p)*kk(i5,m)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,n)*kk(i2,m)*kk(i5,p)*g1(i1,i5)*g2(i2,i5)
       - kk(i1,n)*kk(i2,m)*kk(i5,p)*g3(i1,i2)
       - kk(i1,n)*kk(i2,p)*kk(i5,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,n)*kk(i5,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,m)*kk(i5,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,p)*kk(i5,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i5,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i5,p)*g3(i2,i5)
       + kk(i1,m)*kk(i2,p)*kk(i5,n)*g3(i2,i5)
       + kk(i1,p)*kk(i2,m)*kk(i5,n)*g3(i2,i5)
       + kk(i1,p)*kk(i2,n)*kk(i5,m)*g3(i2,i5)
       + kk(i1,n)*kk(i2,p)*kk(i5,m)*g3(i2,i5)
       + kk(i1,n)*kk(i2,m)*kk(i5,p)*g3(i2,i5)
       + kk(i1,n)*kk(i2,m)*kk(i6,p)*g1(i1,i6)*g2(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i6,m)*g1(i1,i6)*g2(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i6,n)*g1(i1,i6)*g2(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i6,p)*g1(i1,i6)*g2(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i6,p)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,m)*kk(i2,p)*kk(i6,n)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,p)*kk(i2,m)*kk(i6,n)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,p)*kk(i2,n)*kk(i6,m)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,n)*kk(i2,p)*kk(i6,m)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,n)*kk(i2,m)*kk(i6,p)*g1(i1,i6)*g2(i2,i6)
       - kk(i1,n)*kk(i2,m)*kk(i6,p)*g3(i1,i2)
       - kk(i1,n)*kk(i2,p)*kk(i6,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,n)*kk(i6,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,m)*kk(i6,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,p)*kk(i6,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i6,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i6,p)*g3(i2,i6)
       + kk(i1,m)*kk(i2,p)*kk(i6,n)*g3(i2,i6)
       + kk(i1,p)*kk(i2,m)*kk(i6,n)*g3(i2,i6)
       + kk(i1,p)*kk(i2,n)*kk(i6,m)*g3(i2,i6)
       + kk(i1,n)*kk(i2,p)*kk(i6,m)*g3(i2,i6)
       + kk(i1,n)*kk(i2,m)*kk(i6,p)*g3(i2,i6)
       + kk(i1,n)*kk(i2,m)*kk(i7,p)*g1(i1,i7)*g2(i1,i2)
       + kk(i1,n)*kk(i2,p)*kk(i7,m)*g1(i1,i7)*g2(i1,i2)
       + kk(i1,p)*kk(i2,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i2)
       + kk(i1,p)*kk(i2,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i2)
       + kk(i1,m)*kk(i2,p)*kk(i7,n)*g1(i1,i7)*g2(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i7,p)*g1(i1,i7)*g2(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i7,p)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,m)*kk(i2,p)*kk(i7,n)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,p)*kk(i2,m)*kk(i7,n)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,p)*kk(i2,n)*kk(i7,m)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,n)*kk(i2,p)*kk(i7,m)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,n)*kk(i2,m)*kk(i7,p)*g1(i1,i7)*g2(i2,i7)
       - kk(i1,n)*kk(i2,m)*kk(i7,p)*g3(i1,i2)
       - kk(i1,n)*kk(i2,p)*kk(i7,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,n)*kk(i7,m)*g3(i1,i2)
       - kk(i1,p)*kk(i2,m)*kk(i7,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,p)*kk(i7,n)*g3(i1,i2)
       - kk(i1,m)*kk(i2,n)*kk(i7,p)*g3(i1,i2)
       + kk(i1,m)*kk(i2,n)*kk(i7,p)*g3(i2,i7)
       + kk(i1,m)*kk(i2,p)*kk(i7,n)*g3(i2,i7)
       + kk(i1,p)*kk(i2,m)*kk(i7,n)*g3(i2,i7)
       + kk(i1,p)*kk(i2,n)*kk(i7,m)*g3(i2,i7)
       + kk(i1,n)*kk(i2,p)*kk(i7,m)*g3(i2,i7)
       + kk(i1,n)*kk(i2,m)*kk(i7,p)*g3(i2,i7)
       + kk(i1,n)*kk(i2,m)*g2(i1,i2)*ellf(p)
       + kk(i1,n)*kk(i2,p)*g2(i1,i2)*ellf(m)
       + kk(i1,p)*kk(i2,n)*g2(i1,i2)*ellf(m)
       + kk(i1,p)*kk(i2,m)*g2(i1,i2)*ellf(n)
       + kk(i1,m)*kk(i2,p)*g2(i1,i2)*ellf(n)
       + kk(i1,m)*kk(i2,n)*g2(i1,i2)*ellf(p)
       + kk(i1,m)*kk(i3,n)*kk(i3,p)*g3(i1,i3)
       + kk(i1,m)*kk(i3,p)*kk(i3,n)*g3(i1,i3)
       + kk(i1,p)*kk(i3,m)*kk(i3,n)*g3(i1,i3)
       + kk(i1,p)*kk(i3,n)*kk(i3,m)*g3(i1,i3)
       + kk(i1,n)*kk(i3,p)*kk(i3,m)*g3(i1,i3)
       + kk(i1,n)*kk(i3,m)*kk(i3,p)*g3(i1,i3)
       + kk(i1,n)*kk(i3,m)*kk(i4,p)*g1(i1,i4)*g2(i1,i3)
       + kk(i1,n)*kk(i3,p)*kk(i4,m)*g1(i1,i4)*g2(i1,i3)
       + kk(i1,p)*kk(i3,n)*kk(i4,m)*g1(i1,i4)*g2(i1,i3)
       + kk(i1,p)*kk(i3,m)*kk(i4,n)*g1(i1,i4)*g2(i1,i3)
       + kk(i1,m)*kk(i3,p)*kk(i4,n)*g1(i1,i4)*g2(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i4,p)*g1(i1,i4)*g2(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i4,p)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,m)*kk(i3,p)*kk(i4,n)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,p)*kk(i3,m)*kk(i4,n)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,p)*kk(i3,n)*kk(i4,m)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,n)*kk(i3,p)*kk(i4,m)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,n)*kk(i3,m)*kk(i4,p)*g1(i1,i4)*g2(i3,i4)
       - kk(i1,n)*kk(i3,m)*kk(i4,p)*g3(i1,i3)
       - kk(i1,n)*kk(i3,p)*kk(i4,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,n)*kk(i4,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,m)*kk(i4,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,p)*kk(i4,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i4,p)*g3(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i4,p)*g3(i3,i4)
       + kk(i1,m)*kk(i3,p)*kk(i4,n)*g3(i3,i4)
       + kk(i1,p)*kk(i3,m)*kk(i4,n)*g3(i3,i4)
       + kk(i1,p)*kk(i3,n)*kk(i4,m)*g3(i3,i4)
       + kk(i1,n)*kk(i3,p)*kk(i4,m)*g3(i3,i4)
       + kk(i1,n)*kk(i3,m)*kk(i4,p)*g3(i3,i4)
       + kk(i1,n)*kk(i3,m)*kk(i5,p)*g1(i1,i5)*g2(i1,i3)
       + kk(i1,n)*kk(i3,p)*kk(i5,m)*g1(i1,i5)*g2(i1,i3)
       + kk(i1,p)*kk(i3,n)*kk(i5,m)*g1(i1,i5)*g2(i1,i3)
       + kk(i1,p)*kk(i3,m)*kk(i5,n)*g1(i1,i5)*g2(i1,i3)
       + kk(i1,m)*kk(i3,p)*kk(i5,n)*g1(i1,i5)*g2(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i5,p)*g1(i1,i5)*g2(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i5,p)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,m)*kk(i3,p)*kk(i5,n)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,p)*kk(i3,m)*kk(i5,n)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,p)*kk(i3,n)*kk(i5,m)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,n)*kk(i3,p)*kk(i5,m)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,n)*kk(i3,m)*kk(i5,p)*g1(i1,i5)*g2(i3,i5)
       - kk(i1,n)*kk(i3,m)*kk(i5,p)*g3(i1,i3)
       - kk(i1,n)*kk(i3,p)*kk(i5,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,n)*kk(i5,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,m)*kk(i5,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,p)*kk(i5,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i5,p)*g3(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i5,p)*g3(i3,i5)
       + kk(i1,m)*kk(i3,p)*kk(i5,n)*g3(i3,i5)
       + kk(i1,p)*kk(i3,m)*kk(i5,n)*g3(i3,i5)
       + kk(i1,p)*kk(i3,n)*kk(i5,m)*g3(i3,i5)
       + kk(i1,n)*kk(i3,p)*kk(i5,m)*g3(i3,i5)
       + kk(i1,n)*kk(i3,m)*kk(i5,p)*g3(i3,i5)
       + kk(i1,n)*kk(i3,m)*kk(i6,p)*g1(i1,i6)*g2(i1,i3)
       + kk(i1,n)*kk(i3,p)*kk(i6,m)*g1(i1,i6)*g2(i1,i3)
       + kk(i1,p)*kk(i3,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i3)
       + kk(i1,p)*kk(i3,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i3)
       + kk(i1,m)*kk(i3,p)*kk(i6,n)*g1(i1,i6)*g2(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i6,p)*g1(i1,i6)*g2(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i6,p)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,m)*kk(i3,p)*kk(i6,n)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,p)*kk(i3,m)*kk(i6,n)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,p)*kk(i3,n)*kk(i6,m)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,n)*kk(i3,p)*kk(i6,m)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,n)*kk(i3,m)*kk(i6,p)*g1(i1,i6)*g2(i3,i6)
       - kk(i1,n)*kk(i3,m)*kk(i6,p)*g3(i1,i3)
       - kk(i1,n)*kk(i3,p)*kk(i6,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,n)*kk(i6,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,m)*kk(i6,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,p)*kk(i6,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i6,p)*g3(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i6,p)*g3(i3,i6)
       + kk(i1,m)*kk(i3,p)*kk(i6,n)*g3(i3,i6)
       + kk(i1,p)*kk(i3,m)*kk(i6,n)*g3(i3,i6)
       + kk(i1,p)*kk(i3,n)*kk(i6,m)*g3(i3,i6)
       + kk(i1,n)*kk(i3,p)*kk(i6,m)*g3(i3,i6)
       + kk(i1,n)*kk(i3,m)*kk(i6,p)*g3(i3,i6)
       + kk(i1,n)*kk(i3,m)*kk(i7,p)*g1(i1,i7)*g2(i1,i3)
       + kk(i1,n)*kk(i3,p)*kk(i7,m)*g1(i1,i7)*g2(i1,i3)
       + kk(i1,p)*kk(i3,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i3)
       + kk(i1,p)*kk(i3,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i3)
       + kk(i1,m)*kk(i3,p)*kk(i7,n)*g1(i1,i7)*g2(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i7,p)*g1(i1,i7)*g2(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i7,p)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,m)*kk(i3,p)*kk(i7,n)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,p)*kk(i3,m)*kk(i7,n)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,p)*kk(i3,n)*kk(i7,m)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,n)*kk(i3,p)*kk(i7,m)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,n)*kk(i3,m)*kk(i7,p)*g1(i1,i7)*g2(i3,i7)
       - kk(i1,n)*kk(i3,m)*kk(i7,p)*g3(i1,i3)
       - kk(i1,n)*kk(i3,p)*kk(i7,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,n)*kk(i7,m)*g3(i1,i3)
       - kk(i1,p)*kk(i3,m)*kk(i7,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,p)*kk(i7,n)*g3(i1,i3)
       - kk(i1,m)*kk(i3,n)*kk(i7,p)*g3(i1,i3)
       + kk(i1,m)*kk(i3,n)*kk(i7,p)*g3(i3,i7)
       + kk(i1,m)*kk(i3,p)*kk(i7,n)*g3(i3,i7)
       + kk(i1,p)*kk(i3,m)*kk(i7,n)*g3(i3,i7)
       + kk(i1,p)*kk(i3,n)*kk(i7,m)*g3(i3,i7)
       + kk(i1,n)*kk(i3,p)*kk(i7,m)*g3(i3,i7)
       + kk(i1,n)*kk(i3,m)*kk(i7,p)*g3(i3,i7)
       + kk(i1,n)*kk(i3,m)*g2(i1,i3)*ellf(p)
       + kk(i1,n)*kk(i3,p)*g2(i1,i3)*ellf(m)
       + kk(i1,p)*kk(i3,n)*g2(i1,i3)*ellf(m)
       + kk(i1,p)*kk(i3,m)*g2(i1,i3)*ellf(n)
       + kk(i1,m)*kk(i3,p)*g2(i1,i3)*ellf(n)
       + kk(i1,m)*kk(i3,n)*g2(i1,i3)*ellf(p)
       + kk(i1,m)*kk(i4,n)*kk(i4,p)*g3(i1,i4)
       + kk(i1,m)*kk(i4,p)*kk(i4,n)*g3(i1,i4)
       + kk(i1,p)*kk(i4,m)*kk(i4,n)*g3(i1,i4)
       + kk(i1,p)*kk(i4,n)*kk(i4,m)*g3(i1,i4)
       + kk(i1,n)*kk(i4,p)*kk(i4,m)*g3(i1,i4)
       + kk(i1,n)*kk(i4,m)*kk(i4,p)*g3(i1,i4)
       + kk(i1,n)*kk(i4,m)*kk(i5,p)*g1(i1,i5)*g2(i1,i4)
       + kk(i1,n)*kk(i4,p)*kk(i5,m)*g1(i1,i5)*g2(i1,i4)
       + kk(i1,p)*kk(i4,n)*kk(i5,m)*g1(i1,i5)*g2(i1,i4)
       + kk(i1,p)*kk(i4,m)*kk(i5,n)*g1(i1,i5)*g2(i1,i4)
       + kk(i1,m)*kk(i4,p)*kk(i5,n)*g1(i1,i5)*g2(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i5,p)*g1(i1,i5)*g2(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i5,p)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,m)*kk(i4,p)*kk(i5,n)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,p)*kk(i4,m)*kk(i5,n)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,p)*kk(i4,n)*kk(i5,m)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,n)*kk(i4,p)*kk(i5,m)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,n)*kk(i4,m)*kk(i5,p)*g1(i1,i5)*g2(i4,i5)
       - kk(i1,n)*kk(i4,m)*kk(i5,p)*g3(i1,i4)
       - kk(i1,n)*kk(i4,p)*kk(i5,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,n)*kk(i5,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,m)*kk(i5,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,p)*kk(i5,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i5,p)*g3(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i5,p)*g3(i4,i5)
       + kk(i1,m)*kk(i4,p)*kk(i5,n)*g3(i4,i5)
       + kk(i1,p)*kk(i4,m)*kk(i5,n)*g3(i4,i5)
       + kk(i1,p)*kk(i4,n)*kk(i5,m)*g3(i4,i5)
       + kk(i1,n)*kk(i4,p)*kk(i5,m)*g3(i4,i5)
       + kk(i1,n)*kk(i4,m)*kk(i5,p)*g3(i4,i5)
       + kk(i1,n)*kk(i4,m)*kk(i6,p)*g1(i1,i6)*g2(i1,i4)
       + kk(i1,n)*kk(i4,p)*kk(i6,m)*g1(i1,i6)*g2(i1,i4)
       + kk(i1,p)*kk(i4,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i4)
       + kk(i1,p)*kk(i4,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i4)
       + kk(i1,m)*kk(i4,p)*kk(i6,n)*g1(i1,i6)*g2(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i6,p)*g1(i1,i6)*g2(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i6,p)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,m)*kk(i4,p)*kk(i6,n)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,p)*kk(i4,m)*kk(i6,n)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,p)*kk(i4,n)*kk(i6,m)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,n)*kk(i4,p)*kk(i6,m)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,n)*kk(i4,m)*kk(i6,p)*g1(i1,i6)*g2(i4,i6)
       - kk(i1,n)*kk(i4,m)*kk(i6,p)*g3(i1,i4)
       - kk(i1,n)*kk(i4,p)*kk(i6,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,n)*kk(i6,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,m)*kk(i6,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,p)*kk(i6,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i6,p)*g3(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i6,p)*g3(i4,i6)
       + kk(i1,m)*kk(i4,p)*kk(i6,n)*g3(i4,i6)
       + kk(i1,p)*kk(i4,m)*kk(i6,n)*g3(i4,i6)
       + kk(i1,p)*kk(i4,n)*kk(i6,m)*g3(i4,i6)
       + kk(i1,n)*kk(i4,p)*kk(i6,m)*g3(i4,i6)
       + kk(i1,n)*kk(i4,m)*kk(i6,p)*g3(i4,i6)
       + kk(i1,n)*kk(i4,m)*kk(i7,p)*g1(i1,i7)*g2(i1,i4)
       + kk(i1,n)*kk(i4,p)*kk(i7,m)*g1(i1,i7)*g2(i1,i4)
       + kk(i1,p)*kk(i4,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i4)
       + kk(i1,p)*kk(i4,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i4)
       + kk(i1,m)*kk(i4,p)*kk(i7,n)*g1(i1,i7)*g2(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i7,p)*g1(i1,i7)*g2(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i7,p)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,m)*kk(i4,p)*kk(i7,n)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,p)*kk(i4,m)*kk(i7,n)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,p)*kk(i4,n)*kk(i7,m)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,n)*kk(i4,p)*kk(i7,m)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,n)*kk(i4,m)*kk(i7,p)*g1(i1,i7)*g2(i4,i7)
       - kk(i1,n)*kk(i4,m)*kk(i7,p)*g3(i1,i4)
       - kk(i1,n)*kk(i4,p)*kk(i7,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,n)*kk(i7,m)*g3(i1,i4)
       - kk(i1,p)*kk(i4,m)*kk(i7,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,p)*kk(i7,n)*g3(i1,i4)
       - kk(i1,m)*kk(i4,n)*kk(i7,p)*g3(i1,i4)
       + kk(i1,m)*kk(i4,n)*kk(i7,p)*g3(i4,i7)
       + kk(i1,m)*kk(i4,p)*kk(i7,n)*g3(i4,i7)
       + kk(i1,p)*kk(i4,m)*kk(i7,n)*g3(i4,i7)
       + kk(i1,p)*kk(i4,n)*kk(i7,m)*g3(i4,i7)
       + kk(i1,n)*kk(i4,p)*kk(i7,m)*g3(i4,i7)
       + kk(i1,n)*kk(i4,m)*kk(i7,p)*g3(i4,i7)
       + kk(i1,n)*kk(i4,m)*g2(i1,i4)*ellf(p)
       + kk(i1,n)*kk(i4,p)*g2(i1,i4)*ellf(m)
       + kk(i1,p)*kk(i4,n)*g2(i1,i4)*ellf(m)
       + kk(i1,p)*kk(i4,m)*g2(i1,i4)*ellf(n)
       + kk(i1,m)*kk(i4,p)*g2(i1,i4)*ellf(n)
       + kk(i1,m)*kk(i4,n)*g2(i1,i4)*ellf(p)
       + kk(i1,m)*kk(i5,n)*kk(i5,p)*g3(i1,i5)
       + kk(i1,m)*kk(i5,p)*kk(i5,n)*g3(i1,i5)
       + kk(i1,p)*kk(i5,m)*kk(i5,n)*g3(i1,i5)
       + kk(i1,p)*kk(i5,n)*kk(i5,m)*g3(i1,i5)
       + kk(i1,n)*kk(i5,p)*kk(i5,m)*g3(i1,i5)
       + kk(i1,n)*kk(i5,m)*kk(i5,p)*g3(i1,i5)
       + kk(i1,n)*kk(i5,m)*kk(i6,p)*g1(i1,i6)*g2(i1,i5)
       + kk(i1,n)*kk(i5,p)*kk(i6,m)*g1(i1,i6)*g2(i1,i5)
       + kk(i1,p)*kk(i5,n)*kk(i6,m)*g1(i1,i6)*g2(i1,i5)
       + kk(i1,p)*kk(i5,m)*kk(i6,n)*g1(i1,i6)*g2(i1,i5)
       + kk(i1,m)*kk(i5,p)*kk(i6,n)*g1(i1,i6)*g2(i1,i5)
       + kk(i1,m)*kk(i5,n)*kk(i6,p)*g1(i1,i6)*g2(i1,i5)
       - kk(i1,m)*kk(i5,n)*kk(i6,p)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,m)*kk(i5,p)*kk(i6,n)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,p)*kk(i5,m)*kk(i6,n)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,p)*kk(i5,n)*kk(i6,m)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,n)*kk(i5,p)*kk(i6,m)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,n)*kk(i5,m)*kk(i6,p)*g1(i1,i6)*g2(i5,i6)
       - kk(i1,n)*kk(i5,m)*kk(i6,p)*g3(i1,i5)
       - kk(i1,n)*kk(i5,p)*kk(i6,m)*g3(i1,i5)
       - kk(i1,p)*kk(i5,n)*kk(i6,m)*g3(i1,i5)
       - kk(i1,p)*kk(i5,m)*kk(i6,n)*g3(i1,i5)
       - kk(i1,m)*kk(i5,p)*kk(i6,n)*g3(i1,i5)
       - kk(i1,m)*kk(i5,n)*kk(i6,p)*g3(i1,i5)
       + kk(i1,m)*kk(i5,n)*kk(i6,p)*g3(i5,i6)
       + kk(i1,m)*kk(i5,p)*kk(i6,n)*g3(i5,i6)
       + kk(i1,p)*kk(i5,m)*kk(i6,n)*g3(i5,i6)
       + kk(i1,p)*kk(i5,n)*kk(i6,m)*g3(i5,i6)
       + kk(i1,n)*kk(i5,p)*kk(i6,m)*g3(i5,i6)
       + kk(i1,n)*kk(i5,m)*kk(i6,p)*g3(i5,i6)
       + kk(i1,n)*kk(i5,m)*kk(i7,p)*g1(i1,i7)*g2(i1,i5)
       + kk(i1,n)*kk(i5,p)*kk(i7,m)*g1(i1,i7)*g2(i1,i5)
       + kk(i1,p)*kk(i5,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i5)
       + kk(i1,p)*kk(i5,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i5)
       + kk(i1,m)*kk(i5,p)*kk(i7,n)*g1(i1,i7)*g2(i1,i5)
       + kk(i1,m)*kk(i5,n)*kk(i7,p)*g1(i1,i7)*g2(i1,i5)
       - kk(i1,m)*kk(i5,n)*kk(i7,p)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,m)*kk(i5,p)*kk(i7,n)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,p)*kk(i5,m)*kk(i7,n)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,p)*kk(i5,n)*kk(i7,m)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,n)*kk(i5,p)*kk(i7,m)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,n)*kk(i5,m)*kk(i7,p)*g1(i1,i7)*g2(i5,i7)
       - kk(i1,n)*kk(i5,m)*kk(i7,p)*g3(i1,i5)
       - kk(i1,n)*kk(i5,p)*kk(i7,m)*g3(i1,i5)
       - kk(i1,p)*kk(i5,n)*kk(i7,m)*g3(i1,i5)
       - kk(i1,p)*kk(i5,m)*kk(i7,n)*g3(i1,i5)
       - kk(i1,m)*kk(i5,p)*kk(i7,n)*g3(i1,i5)
       - kk(i1,m)*kk(i5,n)*kk(i7,p)*g3(i1,i5)
       + kk(i1,m)*kk(i5,n)*kk(i7,p)*g3(i5,i7)
       + kk(i1,m)*kk(i5,p)*kk(i7,n)*g3(i5,i7)
       + kk(i1,p)*kk(i5,m)*kk(i7,n)*g3(i5,i7)
       + kk(i1,p)*kk(i5,n)*kk(i7,m)*g3(i5,i7)
       + kk(i1,n)*kk(i5,p)*kk(i7,m)*g3(i5,i7)
       + kk(i1,n)*kk(i5,m)*kk(i7,p)*g3(i5,i7)
       + kk(i1,n)*kk(i5,m)*g2(i1,i5)*ellf(p)
       + kk(i1,n)*kk(i5,p)*g2(i1,i5)*ellf(m)
       + kk(i1,p)*kk(i5,n)*g2(i1,i5)*ellf(m)
       + kk(i1,p)*kk(i5,m)*g2(i1,i5)*ellf(n)
       + kk(i1,m)*kk(i5,p)*g2(i1,i5)*ellf(n)
       + kk(i1,m)*kk(i5,n)*g2(i1,i5)*ellf(p)
       + kk(i1,m)*kk(i6,n)*kk(i6,p)*g3(i1,i6)
       + kk(i1,m)*kk(i6,p)*kk(i6,n)*g3(i1,i6)
       + kk(i1,p)*kk(i6,m)*kk(i6,n)*g3(i1,i6)
       + kk(i1,p)*kk(i6,n)*kk(i6,m)*g3(i1,i6)
       + kk(i1,n)*kk(i6,p)*kk(i6,m)*g3(i1,i6)
       + kk(i1,n)*kk(i6,m)*kk(i6,p)*g3(i1,i6)
       + kk(i1,n)*kk(i6,m)*kk(i7,p)*g1(i1,i7)*g2(i1,i6)
       + kk(i1,n)*kk(i6,p)*kk(i7,m)*g1(i1,i7)*g2(i1,i6)
       + kk(i1,p)*kk(i6,n)*kk(i7,m)*g1(i1,i7)*g2(i1,i6)
       + kk(i1,p)*kk(i6,m)*kk(i7,n)*g1(i1,i7)*g2(i1,i6)
       + kk(i1,m)*kk(i6,p)*kk(i7,n)*g1(i1,i7)*g2(i1,i6)
       + kk(i1,m)*kk(i6,n)*kk(i7,p)*g1(i1,i7)*g2(i1,i6)
       - kk(i1,m)*kk(i6,n)*kk(i7,p)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,m)*kk(i6,p)*kk(i7,n)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,p)*kk(i6,m)*kk(i7,n)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,p)*kk(i6,n)*kk(i7,m)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,n)*kk(i6,p)*kk(i7,m)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,n)*kk(i6,m)*kk(i7,p)*g1(i1,i7)*g2(i6,i7)
       - kk(i1,n)*kk(i6,m)*kk(i7,p)*g3(i1,i6)
       - kk(i1,n)*kk(i6,p)*kk(i7,m)*g3(i1,i6)
       - kk(i1,p)*kk(i6,n)*kk(i7,m)*g3(i1,i6)
       - kk(i1,p)*kk(i6,m)*kk(i7,n)*g3(i1,i6)
       - kk(i1,m)*kk(i6,p)*kk(i7,n)*g3(i1,i6)
       - kk(i1,m)*kk(i6,n)*kk(i7,p)*g3(i1,i6)
       + kk(i1,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       + kk(i1,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       + kk(i1,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       + kk(i1,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       + kk(i1,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       + kk(i1,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i1,n)*kk(i6,m)*g2(i1,i6)*ellf(p)
       + kk(i1,n)*kk(i6,p)*g2(i1,i6)*ellf(m)
       + kk(i1,p)*kk(i6,n)*g2(i1,i6)*ellf(m)
       + kk(i1,p)*kk(i6,m)*g2(i1,i6)*ellf(n)
       + kk(i1,m)*kk(i6,p)*g2(i1,i6)*ellf(n)
       + kk(i1,m)*kk(i6,n)*g2(i1,i6)*ellf(p)
       + kk(i1,m)*kk(i7,n)*kk(i7,p)*g3(i1,i7)
       + kk(i1,m)*kk(i7,p)*kk(i7,n)*g3(i1,i7)
       + kk(i1,p)*kk(i7,m)*kk(i7,n)*g3(i1,i7)
       + kk(i1,p)*kk(i7,n)*kk(i7,m)*g3(i1,i7)
       + kk(i1,n)*kk(i7,p)*kk(i7,m)*g3(i1,i7)
       + kk(i1,n)*kk(i7,m)*kk(i7,p)*g3(i1,i7)
       + kk(i1,n)*kk(i7,m)*g2(i1,i7)*ellf(p)
       + kk(i1,n)*kk(i7,p)*g2(i1,i7)*ellf(m)
       + kk(i1,p)*kk(i7,n)*g2(i1,i7)*ellf(m)
       + kk(i1,p)*kk(i7,m)*g2(i1,i7)*ellf(n)
       + kk(i1,m)*kk(i7,p)*g2(i1,i7)*ellf(n)
       + kk(i1,m)*kk(i7,n)*g2(i1,i7)*ellf(p)
       - kk(i2,m)*kk(i2,n)*kk(i3,p)*g3(i2,i3)
       - kk(i2,m)*kk(i2,p)*kk(i3,n)*g3(i2,i3)
       - kk(i2,p)*kk(i2,m)*kk(i3,n)*g3(i2,i3)
       - kk(i2,p)*kk(i2,n)*kk(i3,m)*g3(i2,i3)
       - kk(i2,n)*kk(i2,p)*kk(i3,m)*g3(i2,i3)
       - kk(i2,n)*kk(i2,m)*kk(i3,p)*g3(i2,i3)
       - kk(i2,n)*kk(i2,m)*kk(i4,p)*g3(i2,i4)
       - kk(i2,n)*kk(i2,p)*kk(i4,m)*g3(i2,i4)
       - kk(i2,p)*kk(i2,n)*kk(i4,m)*g3(i2,i4)
       - kk(i2,p)*kk(i2,m)*kk(i4,n)*g3(i2,i4)
       - kk(i2,m)*kk(i2,p)*kk(i4,n)*g3(i2,i4)
       - kk(i2,m)*kk(i2,n)*kk(i4,p)*g3(i2,i4)
       - kk(i2,m)*kk(i2,n)*kk(i5,p)*g3(i2,i5)
       - kk(i2,m)*kk(i2,p)*kk(i5,n)*g3(i2,i5)
       - kk(i2,p)*kk(i2,m)*kk(i5,n)*g3(i2,i5)
       - kk(i2,p)*kk(i2,n)*kk(i5,m)*g3(i2,i5)
       - kk(i2,n)*kk(i2,p)*kk(i5,m)*g3(i2,i5)
       - kk(i2,n)*kk(i2,m)*kk(i5,p)*g3(i2,i5)
       - kk(i2,n)*kk(i2,m)*kk(i6,p)*g3(i2,i6)
       - kk(i2,n)*kk(i2,p)*kk(i6,m)*g3(i2,i6)
       - kk(i2,p)*kk(i2,n)*kk(i6,m)*g3(i2,i6)
       - kk(i2,p)*kk(i2,m)*kk(i6,n)*g3(i2,i6)
       - kk(i2,m)*kk(i2,p)*kk(i6,n)*g3(i2,i6)
       - kk(i2,m)*kk(i2,n)*kk(i6,p)*g3(i2,i6)
       - kk(i2,m)*kk(i2,n)*kk(i7,p)*g3(i2,i7)
       - kk(i2,m)*kk(i2,p)*kk(i7,n)*g3(i2,i7)
       - kk(i2,p)*kk(i2,m)*kk(i7,n)*g3(i2,i7)
       - kk(i2,p)*kk(i2,n)*kk(i7,m)*g3(i2,i7)
       - kk(i2,n)*kk(i2,p)*kk(i7,m)*g3(i2,i7)
       - kk(i2,n)*kk(i2,m)*kk(i7,p)*g3(i2,i7)
       + kk(i2,n)*kk(i3,m)*kk(i3,p)*g3(i2,i3)
       + kk(i2,n)*kk(i3,p)*kk(i3,m)*g3(i2,i3)
       + kk(i2,p)*kk(i3,n)*kk(i3,m)*g3(i2,i3)
       + kk(i2,p)*kk(i3,m)*kk(i3,n)*g3(i2,i3)
       + kk(i2,m)*kk(i3,p)*kk(i3,n)*g3(i2,i3)
       + kk(i2,m)*kk(i3,n)*kk(i3,p)*g3(i2,i3)
       + kk(i2,m)*kk(i3,n)*kk(i4,p)*g1(i2,i4)*g2(i2,i3)
       + kk(i2,m)*kk(i3,p)*kk(i4,n)*g1(i2,i4)*g2(i2,i3)
       + kk(i2,p)*kk(i3,m)*kk(i4,n)*g1(i2,i4)*g2(i2,i3)
       + kk(i2,p)*kk(i3,n)*kk(i4,m)*g1(i2,i4)*g2(i2,i3)
       + kk(i2,n)*kk(i3,p)*kk(i4,m)*g1(i2,i4)*g2(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i4,p)*g1(i2,i4)*g2(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i4,p)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,n)*kk(i3,p)*kk(i4,m)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,p)*kk(i3,n)*kk(i4,m)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,p)*kk(i3,m)*kk(i4,n)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,m)*kk(i3,p)*kk(i4,n)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,m)*kk(i3,n)*kk(i4,p)*g1(i2,i4)*g2(i3,i4)
       - kk(i2,m)*kk(i3,n)*kk(i4,p)*g3(i2,i3)
       - kk(i2,m)*kk(i3,p)*kk(i4,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,m)*kk(i4,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,n)*kk(i4,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,p)*kk(i4,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i4,p)*g3(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i4,p)*g3(i3,i4)
       + kk(i2,n)*kk(i3,p)*kk(i4,m)*g3(i3,i4)
       + kk(i2,p)*kk(i3,n)*kk(i4,m)*g3(i3,i4)
       + kk(i2,p)*kk(i3,m)*kk(i4,n)*g3(i3,i4)
       + kk(i2,m)*kk(i3,p)*kk(i4,n)*g3(i3,i4)
       + kk(i2,m)*kk(i3,n)*kk(i4,p)*g3(i3,i4)
       + kk(i2,m)*kk(i3,n)*kk(i5,p)*g1(i2,i5)*g2(i2,i3)
       + kk(i2,m)*kk(i3,p)*kk(i5,n)*g1(i2,i5)*g2(i2,i3)
       + kk(i2,p)*kk(i3,m)*kk(i5,n)*g1(i2,i5)*g2(i2,i3)
       + kk(i2,p)*kk(i3,n)*kk(i5,m)*g1(i2,i5)*g2(i2,i3)
       + kk(i2,n)*kk(i3,p)*kk(i5,m)*g1(i2,i5)*g2(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i5,p)*g1(i2,i5)*g2(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i5,p)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,n)*kk(i3,p)*kk(i5,m)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,p)*kk(i3,n)*kk(i5,m)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,p)*kk(i3,m)*kk(i5,n)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,m)*kk(i3,p)*kk(i5,n)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,m)*kk(i3,n)*kk(i5,p)*g1(i2,i5)*g2(i3,i5)
       - kk(i2,m)*kk(i3,n)*kk(i5,p)*g3(i2,i3)
       - kk(i2,m)*kk(i3,p)*kk(i5,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,m)*kk(i5,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,n)*kk(i5,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,p)*kk(i5,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i5,p)*g3(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i5,p)*g3(i3,i5)
       + kk(i2,n)*kk(i3,p)*kk(i5,m)*g3(i3,i5)
       + kk(i2,p)*kk(i3,n)*kk(i5,m)*g3(i3,i5)
       + kk(i2,p)*kk(i3,m)*kk(i5,n)*g3(i3,i5)
       + kk(i2,m)*kk(i3,p)*kk(i5,n)*g3(i3,i5)
       + kk(i2,m)*kk(i3,n)*kk(i5,p)*g3(i3,i5)
       + kk(i2,m)*kk(i3,n)*kk(i6,p)*g1(i2,i6)*g2(i2,i3)
       + kk(i2,m)*kk(i3,p)*kk(i6,n)*g1(i2,i6)*g2(i2,i3)
       + kk(i2,p)*kk(i3,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i3)
       + kk(i2,p)*kk(i3,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i3)
       + kk(i2,n)*kk(i3,p)*kk(i6,m)*g1(i2,i6)*g2(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i6,p)*g1(i2,i6)*g2(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i6,p)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,n)*kk(i3,p)*kk(i6,m)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,p)*kk(i3,n)*kk(i6,m)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,p)*kk(i3,m)*kk(i6,n)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,m)*kk(i3,p)*kk(i6,n)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,m)*kk(i3,n)*kk(i6,p)*g1(i2,i6)*g2(i3,i6)
       - kk(i2,m)*kk(i3,n)*kk(i6,p)*g3(i2,i3)
       - kk(i2,m)*kk(i3,p)*kk(i6,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,m)*kk(i6,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,n)*kk(i6,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,p)*kk(i6,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i6,p)*g3(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i6,p)*g3(i3,i6)
       + kk(i2,n)*kk(i3,p)*kk(i6,m)*g3(i3,i6)
       + kk(i2,p)*kk(i3,n)*kk(i6,m)*g3(i3,i6)
       + kk(i2,p)*kk(i3,m)*kk(i6,n)*g3(i3,i6)
       + kk(i2,m)*kk(i3,p)*kk(i6,n)*g3(i3,i6)
       + kk(i2,m)*kk(i3,n)*kk(i6,p)*g3(i3,i6)
       + kk(i2,m)*kk(i3,n)*kk(i7,p)*g1(i2,i7)*g2(i2,i3)
       + kk(i2,m)*kk(i3,p)*kk(i7,n)*g1(i2,i7)*g2(i2,i3)
       + kk(i2,p)*kk(i3,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i3)
       + kk(i2,p)*kk(i3,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i3)
       + kk(i2,n)*kk(i3,p)*kk(i7,m)*g1(i2,i7)*g2(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i7,p)*g1(i2,i7)*g2(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i7,p)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,n)*kk(i3,p)*kk(i7,m)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,p)*kk(i3,n)*kk(i7,m)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,p)*kk(i3,m)*kk(i7,n)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,m)*kk(i3,p)*kk(i7,n)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,m)*kk(i3,n)*kk(i7,p)*g1(i2,i7)*g2(i3,i7)
       - kk(i2,m)*kk(i3,n)*kk(i7,p)*g3(i2,i3)
       - kk(i2,m)*kk(i3,p)*kk(i7,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,m)*kk(i7,n)*g3(i2,i3)
       - kk(i2,p)*kk(i3,n)*kk(i7,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,p)*kk(i7,m)*g3(i2,i3)
       - kk(i2,n)*kk(i3,m)*kk(i7,p)*g3(i2,i3)
       + kk(i2,n)*kk(i3,m)*kk(i7,p)*g3(i3,i7)
       + kk(i2,n)*kk(i3,p)*kk(i7,m)*g3(i3,i7)
       + kk(i2,p)*kk(i3,n)*kk(i7,m)*g3(i3,i7)
       + kk(i2,p)*kk(i3,m)*kk(i7,n)*g3(i3,i7)
       + kk(i2,m)*kk(i3,p)*kk(i7,n)*g3(i3,i7)
       + kk(i2,m)*kk(i3,n)*kk(i7,p)*g3(i3,i7)
       + kk(i2,m)*kk(i3,n)*g2(i2,i3)*ellf(p)
       + kk(i2,m)*kk(i3,p)*g2(i2,i3)*ellf(n)
       + kk(i2,p)*kk(i3,m)*g2(i2,i3)*ellf(n)
       + kk(i2,p)*kk(i3,n)*g2(i2,i3)*ellf(m)
       + kk(i2,n)*kk(i3,p)*g2(i2,i3)*ellf(m)
       + kk(i2,n)*kk(i3,m)*g2(i2,i3)*ellf(p)
       + kk(i2,n)*kk(i4,m)*kk(i4,p)*g3(i2,i4)
       + kk(i2,n)*kk(i4,p)*kk(i4,m)*g3(i2,i4)
       + kk(i2,p)*kk(i4,n)*kk(i4,m)*g3(i2,i4)
       + kk(i2,p)*kk(i4,m)*kk(i4,n)*g3(i2,i4)
       + kk(i2,m)*kk(i4,p)*kk(i4,n)*g3(i2,i4)
       + kk(i2,m)*kk(i4,n)*kk(i4,p)*g3(i2,i4)
       + kk(i2,m)*kk(i4,n)*kk(i5,p)*g1(i2,i5)*g2(i2,i4)
       + kk(i2,m)*kk(i4,p)*kk(i5,n)*g1(i2,i5)*g2(i2,i4)
       + kk(i2,p)*kk(i4,m)*kk(i5,n)*g1(i2,i5)*g2(i2,i4)
       + kk(i2,p)*kk(i4,n)*kk(i5,m)*g1(i2,i5)*g2(i2,i4)
       + kk(i2,n)*kk(i4,p)*kk(i5,m)*g1(i2,i5)*g2(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i5,p)*g1(i2,i5)*g2(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i5,p)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,n)*kk(i4,p)*kk(i5,m)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,p)*kk(i4,n)*kk(i5,m)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,p)*kk(i4,m)*kk(i5,n)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,m)*kk(i4,p)*kk(i5,n)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,m)*kk(i4,n)*kk(i5,p)*g1(i2,i5)*g2(i4,i5)
       - kk(i2,m)*kk(i4,n)*kk(i5,p)*g3(i2,i4)
       - kk(i2,m)*kk(i4,p)*kk(i5,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,m)*kk(i5,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,n)*kk(i5,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,p)*kk(i5,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i5,p)*g3(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i5,p)*g3(i4,i5)
       + kk(i2,n)*kk(i4,p)*kk(i5,m)*g3(i4,i5)
       + kk(i2,p)*kk(i4,n)*kk(i5,m)*g3(i4,i5)
       + kk(i2,p)*kk(i4,m)*kk(i5,n)*g3(i4,i5)
       + kk(i2,m)*kk(i4,p)*kk(i5,n)*g3(i4,i5)
       + kk(i2,m)*kk(i4,n)*kk(i5,p)*g3(i4,i5)
       + kk(i2,m)*kk(i4,n)*kk(i6,p)*g1(i2,i6)*g2(i2,i4)
       + kk(i2,m)*kk(i4,p)*kk(i6,n)*g1(i2,i6)*g2(i2,i4)
       + kk(i2,p)*kk(i4,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i4)
       + kk(i2,p)*kk(i4,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i4)
       + kk(i2,n)*kk(i4,p)*kk(i6,m)*g1(i2,i6)*g2(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i6,p)*g1(i2,i6)*g2(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i6,p)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,n)*kk(i4,p)*kk(i6,m)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,p)*kk(i4,n)*kk(i6,m)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,p)*kk(i4,m)*kk(i6,n)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,m)*kk(i4,p)*kk(i6,n)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,m)*kk(i4,n)*kk(i6,p)*g1(i2,i6)*g2(i4,i6)
       - kk(i2,m)*kk(i4,n)*kk(i6,p)*g3(i2,i4)
       - kk(i2,m)*kk(i4,p)*kk(i6,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,m)*kk(i6,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,n)*kk(i6,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,p)*kk(i6,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i6,p)*g3(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i6,p)*g3(i4,i6)
       + kk(i2,n)*kk(i4,p)*kk(i6,m)*g3(i4,i6)
       + kk(i2,p)*kk(i4,n)*kk(i6,m)*g3(i4,i6)
       + kk(i2,p)*kk(i4,m)*kk(i6,n)*g3(i4,i6)
       + kk(i2,m)*kk(i4,p)*kk(i6,n)*g3(i4,i6)
       + kk(i2,m)*kk(i4,n)*kk(i6,p)*g3(i4,i6)
       + kk(i2,m)*kk(i4,n)*kk(i7,p)*g1(i2,i7)*g2(i2,i4)
       + kk(i2,m)*kk(i4,p)*kk(i7,n)*g1(i2,i7)*g2(i2,i4)
       + kk(i2,p)*kk(i4,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i4)
       + kk(i2,p)*kk(i4,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i4)
       + kk(i2,n)*kk(i4,p)*kk(i7,m)*g1(i2,i7)*g2(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i7,p)*g1(i2,i7)*g2(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i7,p)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,n)*kk(i4,p)*kk(i7,m)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,p)*kk(i4,n)*kk(i7,m)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,p)*kk(i4,m)*kk(i7,n)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,m)*kk(i4,p)*kk(i7,n)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,m)*kk(i4,n)*kk(i7,p)*g1(i2,i7)*g2(i4,i7)
       - kk(i2,m)*kk(i4,n)*kk(i7,p)*g3(i2,i4)
       - kk(i2,m)*kk(i4,p)*kk(i7,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,m)*kk(i7,n)*g3(i2,i4)
       - kk(i2,p)*kk(i4,n)*kk(i7,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,p)*kk(i7,m)*g3(i2,i4)
       - kk(i2,n)*kk(i4,m)*kk(i7,p)*g3(i2,i4)
       + kk(i2,n)*kk(i4,m)*kk(i7,p)*g3(i4,i7)
       + kk(i2,n)*kk(i4,p)*kk(i7,m)*g3(i4,i7)
       + kk(i2,p)*kk(i4,n)*kk(i7,m)*g3(i4,i7)
       + kk(i2,p)*kk(i4,m)*kk(i7,n)*g3(i4,i7)
       + kk(i2,m)*kk(i4,p)*kk(i7,n)*g3(i4,i7)
       + kk(i2,m)*kk(i4,n)*kk(i7,p)*g3(i4,i7)
       + kk(i2,m)*kk(i4,n)*g2(i2,i4)*ellf(p)
       + kk(i2,m)*kk(i4,p)*g2(i2,i4)*ellf(n)
       + kk(i2,p)*kk(i4,m)*g2(i2,i4)*ellf(n)
       + kk(i2,p)*kk(i4,n)*g2(i2,i4)*ellf(m)
       + kk(i2,n)*kk(i4,p)*g2(i2,i4)*ellf(m)
       + kk(i2,n)*kk(i4,m)*g2(i2,i4)*ellf(p)
       + kk(i2,n)*kk(i5,m)*kk(i5,p)*g3(i2,i5)
       + kk(i2,n)*kk(i5,p)*kk(i5,m)*g3(i2,i5)
       + kk(i2,p)*kk(i5,n)*kk(i5,m)*g3(i2,i5)
       + kk(i2,p)*kk(i5,m)*kk(i5,n)*g3(i2,i5)
       + kk(i2,m)*kk(i5,p)*kk(i5,n)*g3(i2,i5)
       + kk(i2,m)*kk(i5,n)*kk(i5,p)*g3(i2,i5)
       + kk(i2,m)*kk(i5,n)*kk(i6,p)*g1(i2,i6)*g2(i2,i5)
       + kk(i2,m)*kk(i5,p)*kk(i6,n)*g1(i2,i6)*g2(i2,i5)
       + kk(i2,p)*kk(i5,m)*kk(i6,n)*g1(i2,i6)*g2(i2,i5)
       + kk(i2,p)*kk(i5,n)*kk(i6,m)*g1(i2,i6)*g2(i2,i5)
       + kk(i2,n)*kk(i5,p)*kk(i6,m)*g1(i2,i6)*g2(i2,i5)
       + kk(i2,n)*kk(i5,m)*kk(i6,p)*g1(i2,i6)*g2(i2,i5)
       - kk(i2,n)*kk(i5,m)*kk(i6,p)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,n)*kk(i5,p)*kk(i6,m)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,p)*kk(i5,n)*kk(i6,m)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,p)*kk(i5,m)*kk(i6,n)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,m)*kk(i5,p)*kk(i6,n)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,m)*kk(i5,n)*kk(i6,p)*g1(i2,i6)*g2(i5,i6)
       - kk(i2,m)*kk(i5,n)*kk(i6,p)*g3(i2,i5)
       - kk(i2,m)*kk(i5,p)*kk(i6,n)*g3(i2,i5)
       - kk(i2,p)*kk(i5,m)*kk(i6,n)*g3(i2,i5)
       - kk(i2,p)*kk(i5,n)*kk(i6,m)*g3(i2,i5)
       - kk(i2,n)*kk(i5,p)*kk(i6,m)*g3(i2,i5)
       - kk(i2,n)*kk(i5,m)*kk(i6,p)*g3(i2,i5)
       + kk(i2,n)*kk(i5,m)*kk(i6,p)*g3(i5,i6)
       + kk(i2,n)*kk(i5,p)*kk(i6,m)*g3(i5,i6)
       + kk(i2,p)*kk(i5,n)*kk(i6,m)*g3(i5,i6)
       + kk(i2,p)*kk(i5,m)*kk(i6,n)*g3(i5,i6)
       + kk(i2,m)*kk(i5,p)*kk(i6,n)*g3(i5,i6)
       + kk(i2,m)*kk(i5,n)*kk(i6,p)*g3(i5,i6)
       + kk(i2,m)*kk(i5,n)*kk(i7,p)*g1(i2,i7)*g2(i2,i5)
       + kk(i2,m)*kk(i5,p)*kk(i7,n)*g1(i2,i7)*g2(i2,i5)
       + kk(i2,p)*kk(i5,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i5)
       + kk(i2,p)*kk(i5,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i5)
       + kk(i2,n)*kk(i5,p)*kk(i7,m)*g1(i2,i7)*g2(i2,i5)
       + kk(i2,n)*kk(i5,m)*kk(i7,p)*g1(i2,i7)*g2(i2,i5)
       - kk(i2,n)*kk(i5,m)*kk(i7,p)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,n)*kk(i5,p)*kk(i7,m)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,p)*kk(i5,n)*kk(i7,m)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,p)*kk(i5,m)*kk(i7,n)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,m)*kk(i5,p)*kk(i7,n)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,m)*kk(i5,n)*kk(i7,p)*g1(i2,i7)*g2(i5,i7)
       - kk(i2,m)*kk(i5,n)*kk(i7,p)*g3(i2,i5)
       - kk(i2,m)*kk(i5,p)*kk(i7,n)*g3(i2,i5)
       - kk(i2,p)*kk(i5,m)*kk(i7,n)*g3(i2,i5)
       - kk(i2,p)*kk(i5,n)*kk(i7,m)*g3(i2,i5)
       - kk(i2,n)*kk(i5,p)*kk(i7,m)*g3(i2,i5)
       - kk(i2,n)*kk(i5,m)*kk(i7,p)*g3(i2,i5)
       + kk(i2,n)*kk(i5,m)*kk(i7,p)*g3(i5,i7)
       + kk(i2,n)*kk(i5,p)*kk(i7,m)*g3(i5,i7)
       + kk(i2,p)*kk(i5,n)*kk(i7,m)*g3(i5,i7)
       + kk(i2,p)*kk(i5,m)*kk(i7,n)*g3(i5,i7)
       + kk(i2,m)*kk(i5,p)*kk(i7,n)*g3(i5,i7)
       + kk(i2,m)*kk(i5,n)*kk(i7,p)*g3(i5,i7)
       + kk(i2,m)*kk(i5,n)*g2(i2,i5)*ellf(p)
       + kk(i2,m)*kk(i5,p)*g2(i2,i5)*ellf(n)
       + kk(i2,p)*kk(i5,m)*g2(i2,i5)*ellf(n)
       + kk(i2,p)*kk(i5,n)*g2(i2,i5)*ellf(m)
       + kk(i2,n)*kk(i5,p)*g2(i2,i5)*ellf(m)
       + kk(i2,n)*kk(i5,m)*g2(i2,i5)*ellf(p)
       + kk(i2,n)*kk(i6,m)*kk(i6,p)*g3(i2,i6)
       + kk(i2,n)*kk(i6,p)*kk(i6,m)*g3(i2,i6)
       + kk(i2,p)*kk(i6,n)*kk(i6,m)*g3(i2,i6)
       + kk(i2,p)*kk(i6,m)*kk(i6,n)*g3(i2,i6)
       + kk(i2,m)*kk(i6,p)*kk(i6,n)*g3(i2,i6)
       + kk(i2,m)*kk(i6,n)*kk(i6,p)*g3(i2,i6)
       + kk(i2,m)*kk(i6,n)*kk(i7,p)*g1(i2,i7)*g2(i2,i6)
       + kk(i2,m)*kk(i6,p)*kk(i7,n)*g1(i2,i7)*g2(i2,i6)
       + kk(i2,p)*kk(i6,m)*kk(i7,n)*g1(i2,i7)*g2(i2,i6)
       + kk(i2,p)*kk(i6,n)*kk(i7,m)*g1(i2,i7)*g2(i2,i6)
       + kk(i2,n)*kk(i6,p)*kk(i7,m)*g1(i2,i7)*g2(i2,i6)
       + kk(i2,n)*kk(i6,m)*kk(i7,p)*g1(i2,i7)*g2(i2,i6)
       - kk(i2,n)*kk(i6,m)*kk(i7,p)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,n)*kk(i6,p)*kk(i7,m)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,p)*kk(i6,n)*kk(i7,m)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,p)*kk(i6,m)*kk(i7,n)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,m)*kk(i6,p)*kk(i7,n)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,m)*kk(i6,n)*kk(i7,p)*g1(i2,i7)*g2(i6,i7)
       - kk(i2,m)*kk(i6,n)*kk(i7,p)*g3(i2,i6)
       - kk(i2,m)*kk(i6,p)*kk(i7,n)*g3(i2,i6)
       - kk(i2,p)*kk(i6,m)*kk(i7,n)*g3(i2,i6)
       - kk(i2,p)*kk(i6,n)*kk(i7,m)*g3(i2,i6)
       - kk(i2,n)*kk(i6,p)*kk(i7,m)*g3(i2,i6)
       - kk(i2,n)*kk(i6,m)*kk(i7,p)*g3(i2,i6)
       + kk(i2,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i2,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       + kk(i2,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       + kk(i2,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       + kk(i2,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       + kk(i2,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       + kk(i2,m)*kk(i6,n)*g2(i2,i6)*ellf(p)
       + kk(i2,m)*kk(i6,p)*g2(i2,i6)*ellf(n)
       + kk(i2,p)*kk(i6,m)*g2(i2,i6)*ellf(n)
       + kk(i2,p)*kk(i6,n)*g2(i2,i6)*ellf(m)
       + kk(i2,n)*kk(i6,p)*g2(i2,i6)*ellf(m)
       + kk(i2,n)*kk(i6,m)*g2(i2,i6)*ellf(p)
       + kk(i2,n)*kk(i7,m)*kk(i7,p)*g3(i2,i7)
       + kk(i2,n)*kk(i7,p)*kk(i7,m)*g3(i2,i7)
       + kk(i2,p)*kk(i7,n)*kk(i7,m)*g3(i2,i7)
       + kk(i2,p)*kk(i7,m)*kk(i7,n)*g3(i2,i7)
       + kk(i2,m)*kk(i7,p)*kk(i7,n)*g3(i2,i7)
       + kk(i2,m)*kk(i7,n)*kk(i7,p)*g3(i2,i7)
       + kk(i2,m)*kk(i7,n)*g2(i2,i7)*ellf(p)
       + kk(i2,m)*kk(i7,p)*g2(i2,i7)*ellf(n)
       + kk(i2,p)*kk(i7,m)*g2(i2,i7)*ellf(n)
       + kk(i2,p)*kk(i7,n)*g2(i2,i7)*ellf(m)
       + kk(i2,n)*kk(i7,p)*g2(i2,i7)*ellf(m)
       + kk(i2,n)*kk(i7,m)*g2(i2,i7)*ellf(p)
       - kk(i3,n)*kk(i3,m)*kk(i4,p)*g3(i3,i4)
       - kk(i3,n)*kk(i3,p)*kk(i4,m)*g3(i3,i4)
       - kk(i3,p)*kk(i3,n)*kk(i4,m)*g3(i3,i4)
       - kk(i3,p)*kk(i3,m)*kk(i4,n)*g3(i3,i4)
       - kk(i3,m)*kk(i3,p)*kk(i4,n)*g3(i3,i4)
       - kk(i3,m)*kk(i3,n)*kk(i4,p)*g3(i3,i4)
       - kk(i3,m)*kk(i3,n)*kk(i5,p)*g3(i3,i5)
       - kk(i3,m)*kk(i3,p)*kk(i5,n)*g3(i3,i5)
       - kk(i3,p)*kk(i3,m)*kk(i5,n)*g3(i3,i5)
       - kk(i3,p)*kk(i3,n)*kk(i5,m)*g3(i3,i5)
       - kk(i3,n)*kk(i3,p)*kk(i5,m)*g3(i3,i5)
       - kk(i3,n)*kk(i3,m)*kk(i5,p)*g3(i3,i5)
       - kk(i3,n)*kk(i3,m)*kk(i6,p)*g3(i3,i6)
       - kk(i3,n)*kk(i3,p)*kk(i6,m)*g3(i3,i6)
       - kk(i3,p)*kk(i3,n)*kk(i6,m)*g3(i3,i6)
       - kk(i3,p)*kk(i3,m)*kk(i6,n)*g3(i3,i6)
       - kk(i3,m)*kk(i3,p)*kk(i6,n)*g3(i3,i6)
       - kk(i3,m)*kk(i3,n)*kk(i6,p)*g3(i3,i6)
       - kk(i3,m)*kk(i3,n)*kk(i7,p)*g3(i3,i7)
       - kk(i3,m)*kk(i3,p)*kk(i7,n)*g3(i3,i7)
       - kk(i3,p)*kk(i3,m)*kk(i7,n)*g3(i3,i7)
       - kk(i3,p)*kk(i3,n)*kk(i7,m)*g3(i3,i7)
       - kk(i3,n)*kk(i3,p)*kk(i7,m)*g3(i3,i7)
       - kk(i3,n)*kk(i3,m)*kk(i7,p)*g3(i3,i7)
       + kk(i3,n)*kk(i4,m)*kk(i4,p)*g3(i3,i4)
       + kk(i3,n)*kk(i4,p)*kk(i4,m)*g3(i3,i4)
       + kk(i3,p)*kk(i4,n)*kk(i4,m)*g3(i3,i4)
       + kk(i3,p)*kk(i4,m)*kk(i4,n)*g3(i3,i4)
       + kk(i3,m)*kk(i4,p)*kk(i4,n)*g3(i3,i4)
       + kk(i3,m)*kk(i4,n)*kk(i4,p)*g3(i3,i4)
       + kk(i3,m)*kk(i4,n)*kk(i5,p)*g1(i3,i5)*g2(i3,i4)
       + kk(i3,m)*kk(i4,p)*kk(i5,n)*g1(i3,i5)*g2(i3,i4)
       + kk(i3,p)*kk(i4,m)*kk(i5,n)*g1(i3,i5)*g2(i3,i4)
       + kk(i3,p)*kk(i4,n)*kk(i5,m)*g1(i3,i5)*g2(i3,i4)
       + kk(i3,n)*kk(i4,p)*kk(i5,m)*g1(i3,i5)*g2(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i5,p)*g1(i3,i5)*g2(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i5,p)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,n)*kk(i4,p)*kk(i5,m)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,p)*kk(i4,n)*kk(i5,m)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,p)*kk(i4,m)*kk(i5,n)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,m)*kk(i4,p)*kk(i5,n)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,m)*kk(i4,n)*kk(i5,p)*g1(i3,i5)*g2(i4,i5)
       - kk(i3,m)*kk(i4,n)*kk(i5,p)*g3(i3,i4)
       - kk(i3,m)*kk(i4,p)*kk(i5,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,m)*kk(i5,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,n)*kk(i5,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,p)*kk(i5,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i5,p)*g3(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i5,p)*g3(i4,i5)
       + kk(i3,n)*kk(i4,p)*kk(i5,m)*g3(i4,i5)
       + kk(i3,p)*kk(i4,n)*kk(i5,m)*g3(i4,i5)
       + kk(i3,p)*kk(i4,m)*kk(i5,n)*g3(i4,i5)
       + kk(i3,m)*kk(i4,p)*kk(i5,n)*g3(i4,i5)
       + kk(i3,m)*kk(i4,n)*kk(i5,p)*g3(i4,i5)
       + kk(i3,m)*kk(i4,n)*kk(i6,p)*g1(i3,i6)*g2(i3,i4)
       + kk(i3,m)*kk(i4,p)*kk(i6,n)*g1(i3,i6)*g2(i3,i4)
       + kk(i3,p)*kk(i4,m)*kk(i6,n)*g1(i3,i6)*g2(i3,i4)
       + kk(i3,p)*kk(i4,n)*kk(i6,m)*g1(i3,i6)*g2(i3,i4)
       + kk(i3,n)*kk(i4,p)*kk(i6,m)*g1(i3,i6)*g2(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i6,p)*g1(i3,i6)*g2(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i6,p)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,n)*kk(i4,p)*kk(i6,m)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,p)*kk(i4,n)*kk(i6,m)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,p)*kk(i4,m)*kk(i6,n)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,m)*kk(i4,p)*kk(i6,n)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,m)*kk(i4,n)*kk(i6,p)*g1(i3,i6)*g2(i4,i6)
       - kk(i3,m)*kk(i4,n)*kk(i6,p)*g3(i3,i4)
       - kk(i3,m)*kk(i4,p)*kk(i6,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,m)*kk(i6,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,n)*kk(i6,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,p)*kk(i6,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i6,p)*g3(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i6,p)*g3(i4,i6)
       + kk(i3,n)*kk(i4,p)*kk(i6,m)*g3(i4,i6)
       + kk(i3,p)*kk(i4,n)*kk(i6,m)*g3(i4,i6)
       + kk(i3,p)*kk(i4,m)*kk(i6,n)*g3(i4,i6)
       + kk(i3,m)*kk(i4,p)*kk(i6,n)*g3(i4,i6)
       + kk(i3,m)*kk(i4,n)*kk(i6,p)*g3(i4,i6)
       + kk(i3,m)*kk(i4,n)*kk(i7,p)*g1(i3,i7)*g2(i3,i4)
       + kk(i3,m)*kk(i4,p)*kk(i7,n)*g1(i3,i7)*g2(i3,i4)
       + kk(i3,p)*kk(i4,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i4)
       + kk(i3,p)*kk(i4,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i4)
       + kk(i3,n)*kk(i4,p)*kk(i7,m)*g1(i3,i7)*g2(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i7,p)*g1(i3,i7)*g2(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i7,p)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,n)*kk(i4,p)*kk(i7,m)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,p)*kk(i4,n)*kk(i7,m)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,p)*kk(i4,m)*kk(i7,n)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,m)*kk(i4,p)*kk(i7,n)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,m)*kk(i4,n)*kk(i7,p)*g1(i3,i7)*g2(i4,i7)
       - kk(i3,m)*kk(i4,n)*kk(i7,p)*g3(i3,i4)
       - kk(i3,m)*kk(i4,p)*kk(i7,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,m)*kk(i7,n)*g3(i3,i4)
       - kk(i3,p)*kk(i4,n)*kk(i7,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,p)*kk(i7,m)*g3(i3,i4)
       - kk(i3,n)*kk(i4,m)*kk(i7,p)*g3(i3,i4)
       + kk(i3,n)*kk(i4,m)*kk(i7,p)*g3(i4,i7)
       + kk(i3,n)*kk(i4,p)*kk(i7,m)*g3(i4,i7)
       + kk(i3,p)*kk(i4,n)*kk(i7,m)*g3(i4,i7)
       + kk(i3,p)*kk(i4,m)*kk(i7,n)*g3(i4,i7)
       + kk(i3,m)*kk(i4,p)*kk(i7,n)*g3(i4,i7)
       + kk(i3,m)*kk(i4,n)*kk(i7,p)*g3(i4,i7)
       + kk(i3,m)*kk(i4,n)*g2(i3,i4)*ellf(p)
       + kk(i3,m)*kk(i4,p)*g2(i3,i4)*ellf(n)
       + kk(i3,p)*kk(i4,m)*g2(i3,i4)*ellf(n)
       + kk(i3,p)*kk(i4,n)*g2(i3,i4)*ellf(m)
       + kk(i3,n)*kk(i4,p)*g2(i3,i4)*ellf(m)
       + kk(i3,n)*kk(i4,m)*g2(i3,i4)*ellf(p)
       + kk(i3,n)*kk(i5,m)*kk(i5,p)*g3(i3,i5)
       + kk(i3,n)*kk(i5,p)*kk(i5,m)*g3(i3,i5)
       + kk(i3,p)*kk(i5,n)*kk(i5,m)*g3(i3,i5)
       + kk(i3,p)*kk(i5,m)*kk(i5,n)*g3(i3,i5)
       + kk(i3,m)*kk(i5,p)*kk(i5,n)*g3(i3,i5)
       + kk(i3,m)*kk(i5,n)*kk(i5,p)*g3(i3,i5)
       + kk(i3,m)*kk(i5,n)*kk(i6,p)*g1(i3,i6)*g2(i3,i5)
       + kk(i3,m)*kk(i5,p)*kk(i6,n)*g1(i3,i6)*g2(i3,i5)
       + kk(i3,p)*kk(i5,m)*kk(i6,n)*g1(i3,i6)*g2(i3,i5)
       + kk(i3,p)*kk(i5,n)*kk(i6,m)*g1(i3,i6)*g2(i3,i5)
       + kk(i3,n)*kk(i5,p)*kk(i6,m)*g1(i3,i6)*g2(i3,i5)
       + kk(i3,n)*kk(i5,m)*kk(i6,p)*g1(i3,i6)*g2(i3,i5)
       - kk(i3,n)*kk(i5,m)*kk(i6,p)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,n)*kk(i5,p)*kk(i6,m)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,p)*kk(i5,n)*kk(i6,m)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,p)*kk(i5,m)*kk(i6,n)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,m)*kk(i5,p)*kk(i6,n)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,m)*kk(i5,n)*kk(i6,p)*g1(i3,i6)*g2(i5,i6)
       - kk(i3,m)*kk(i5,n)*kk(i6,p)*g3(i3,i5)
       - kk(i3,m)*kk(i5,p)*kk(i6,n)*g3(i3,i5)
       - kk(i3,p)*kk(i5,m)*kk(i6,n)*g3(i3,i5)
       - kk(i3,p)*kk(i5,n)*kk(i6,m)*g3(i3,i5)
       - kk(i3,n)*kk(i5,p)*kk(i6,m)*g3(i3,i5)
       - kk(i3,n)*kk(i5,m)*kk(i6,p)*g3(i3,i5)
       + kk(i3,n)*kk(i5,m)*kk(i6,p)*g3(i5,i6)
       + kk(i3,n)*kk(i5,p)*kk(i6,m)*g3(i5,i6)
       + kk(i3,p)*kk(i5,n)*kk(i6,m)*g3(i5,i6)
       + kk(i3,p)*kk(i5,m)*kk(i6,n)*g3(i5,i6)
       + kk(i3,m)*kk(i5,p)*kk(i6,n)*g3(i5,i6)
       + kk(i3,m)*kk(i5,n)*kk(i6,p)*g3(i5,i6)
       + kk(i3,m)*kk(i5,n)*kk(i7,p)*g1(i3,i7)*g2(i3,i5)
       + kk(i3,m)*kk(i5,p)*kk(i7,n)*g1(i3,i7)*g2(i3,i5)
       + kk(i3,p)*kk(i5,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i5)
       + kk(i3,p)*kk(i5,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i5)
       + kk(i3,n)*kk(i5,p)*kk(i7,m)*g1(i3,i7)*g2(i3,i5)
       + kk(i3,n)*kk(i5,m)*kk(i7,p)*g1(i3,i7)*g2(i3,i5)
       - kk(i3,n)*kk(i5,m)*kk(i7,p)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,n)*kk(i5,p)*kk(i7,m)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,p)*kk(i5,n)*kk(i7,m)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,p)*kk(i5,m)*kk(i7,n)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,m)*kk(i5,p)*kk(i7,n)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,m)*kk(i5,n)*kk(i7,p)*g1(i3,i7)*g2(i5,i7)
       - kk(i3,m)*kk(i5,n)*kk(i7,p)*g3(i3,i5)
       - kk(i3,m)*kk(i5,p)*kk(i7,n)*g3(i3,i5)
       - kk(i3,p)*kk(i5,m)*kk(i7,n)*g3(i3,i5)
       - kk(i3,p)*kk(i5,n)*kk(i7,m)*g3(i3,i5)
       - kk(i3,n)*kk(i5,p)*kk(i7,m)*g3(i3,i5)
       - kk(i3,n)*kk(i5,m)*kk(i7,p)*g3(i3,i5)
       + kk(i3,n)*kk(i5,m)*kk(i7,p)*g3(i5,i7)
       + kk(i3,n)*kk(i5,p)*kk(i7,m)*g3(i5,i7)
       + kk(i3,p)*kk(i5,n)*kk(i7,m)*g3(i5,i7)
       + kk(i3,p)*kk(i5,m)*kk(i7,n)*g3(i5,i7)
       + kk(i3,m)*kk(i5,p)*kk(i7,n)*g3(i5,i7)
       + kk(i3,m)*kk(i5,n)*kk(i7,p)*g3(i5,i7)
       + kk(i3,m)*kk(i5,n)*g2(i3,i5)*ellf(p)
       + kk(i3,m)*kk(i5,p)*g2(i3,i5)*ellf(n)
       + kk(i3,p)*kk(i5,m)*g2(i3,i5)*ellf(n)
       + kk(i3,p)*kk(i5,n)*g2(i3,i5)*ellf(m)
       + kk(i3,n)*kk(i5,p)*g2(i3,i5)*ellf(m)
       + kk(i3,n)*kk(i5,m)*g2(i3,i5)*ellf(p)
       + kk(i3,n)*kk(i6,m)*kk(i6,p)*g3(i3,i6)
       + kk(i3,n)*kk(i6,p)*kk(i6,m)*g3(i3,i6)
       + kk(i3,p)*kk(i6,n)*kk(i6,m)*g3(i3,i6)
       + kk(i3,p)*kk(i6,m)*kk(i6,n)*g3(i3,i6)
       + kk(i3,m)*kk(i6,p)*kk(i6,n)*g3(i3,i6)
       + kk(i3,m)*kk(i6,n)*kk(i6,p)*g3(i3,i6)
       + kk(i3,m)*kk(i6,n)*kk(i7,p)*g1(i3,i7)*g2(i3,i6)
       + kk(i3,m)*kk(i6,p)*kk(i7,n)*g1(i3,i7)*g2(i3,i6)
       + kk(i3,p)*kk(i6,m)*kk(i7,n)*g1(i3,i7)*g2(i3,i6)
       + kk(i3,p)*kk(i6,n)*kk(i7,m)*g1(i3,i7)*g2(i3,i6)
       + kk(i3,n)*kk(i6,p)*kk(i7,m)*g1(i3,i7)*g2(i3,i6)
       + kk(i3,n)*kk(i6,m)*kk(i7,p)*g1(i3,i7)*g2(i3,i6)
       - kk(i3,n)*kk(i6,m)*kk(i7,p)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,n)*kk(i6,p)*kk(i7,m)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,p)*kk(i6,n)*kk(i7,m)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,p)*kk(i6,m)*kk(i7,n)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,m)*kk(i6,p)*kk(i7,n)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,m)*kk(i6,n)*kk(i7,p)*g1(i3,i7)*g2(i6,i7)
       - kk(i3,m)*kk(i6,n)*kk(i7,p)*g3(i3,i6)
       - kk(i3,m)*kk(i6,p)*kk(i7,n)*g3(i3,i6)
       - kk(i3,p)*kk(i6,m)*kk(i7,n)*g3(i3,i6)
       - kk(i3,p)*kk(i6,n)*kk(i7,m)*g3(i3,i6)
       - kk(i3,n)*kk(i6,p)*kk(i7,m)*g3(i3,i6)
       - kk(i3,n)*kk(i6,m)*kk(i7,p)*g3(i3,i6)
       + kk(i3,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i3,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       + kk(i3,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       + kk(i3,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       + kk(i3,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       + kk(i3,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       + kk(i3,m)*kk(i6,n)*g2(i3,i6)*ellf(p)
       + kk(i3,m)*kk(i6,p)*g2(i3,i6)*ellf(n)
       + kk(i3,p)*kk(i6,m)*g2(i3,i6)*ellf(n)
       + kk(i3,p)*kk(i6,n)*g2(i3,i6)*ellf(m)
       + kk(i3,n)*kk(i6,p)*g2(i3,i6)*ellf(m)
       + kk(i3,n)*kk(i6,m)*g2(i3,i6)*ellf(p)
       + kk(i3,n)*kk(i7,m)*kk(i7,p)*g3(i3,i7)
       + kk(i3,n)*kk(i7,p)*kk(i7,m)*g3(i3,i7)
       + kk(i3,p)*kk(i7,n)*kk(i7,m)*g3(i3,i7)
       + kk(i3,p)*kk(i7,m)*kk(i7,n)*g3(i3,i7)
       + kk(i3,m)*kk(i7,p)*kk(i7,n)*g3(i3,i7)
       + kk(i3,m)*kk(i7,n)*kk(i7,p)*g3(i3,i7)
       + kk(i3,m)*kk(i7,n)*g2(i3,i7)*ellf(p)
       + kk(i3,m)*kk(i7,p)*g2(i3,i7)*ellf(n)
       + kk(i3,p)*kk(i7,m)*g2(i3,i7)*ellf(n)
       + kk(i3,p)*kk(i7,n)*g2(i3,i7)*ellf(m)
       + kk(i3,n)*kk(i7,p)*g2(i3,i7)*ellf(m)
       + kk(i3,n)*kk(i7,m)*g2(i3,i7)*ellf(p)
       - kk(i4,n)*kk(i4,m)*kk(i5,p)*g3(i4,i5)
       - kk(i4,n)*kk(i4,p)*kk(i5,m)*g3(i4,i5)
       - kk(i4,p)*kk(i4,n)*kk(i5,m)*g3(i4,i5)
       - kk(i4,p)*kk(i4,m)*kk(i5,n)*g3(i4,i5)
       - kk(i4,m)*kk(i4,p)*kk(i5,n)*g3(i4,i5)
       - kk(i4,m)*kk(i4,n)*kk(i5,p)*g3(i4,i5)
       - kk(i4,m)*kk(i4,n)*kk(i6,p)*g3(i4,i6)
       - kk(i4,m)*kk(i4,p)*kk(i6,n)*g3(i4,i6)
       - kk(i4,p)*kk(i4,m)*kk(i6,n)*g3(i4,i6)
       - kk(i4,p)*kk(i4,n)*kk(i6,m)*g3(i4,i6)
       - kk(i4,n)*kk(i4,p)*kk(i6,m)*g3(i4,i6)
       - kk(i4,n)*kk(i4,m)*kk(i6,p)*g3(i4,i6)
       - kk(i4,n)*kk(i4,m)*kk(i7,p)*g3(i4,i7)
       - kk(i4,n)*kk(i4,p)*kk(i7,m)*g3(i4,i7)
       - kk(i4,p)*kk(i4,n)*kk(i7,m)*g3(i4,i7)
       - kk(i4,p)*kk(i4,m)*kk(i7,n)*g3(i4,i7)
       - kk(i4,m)*kk(i4,p)*kk(i7,n)*g3(i4,i7)
       - kk(i4,m)*kk(i4,n)*kk(i7,p)*g3(i4,i7)
       + kk(i4,m)*kk(i5,n)*kk(i5,p)*g3(i4,i5)
       + kk(i4,m)*kk(i5,p)*kk(i5,n)*g3(i4,i5)
       + kk(i4,p)*kk(i5,m)*kk(i5,n)*g3(i4,i5)
       + kk(i4,p)*kk(i5,n)*kk(i5,m)*g3(i4,i5)
       + kk(i4,n)*kk(i5,p)*kk(i5,m)*g3(i4,i5)
       + kk(i4,n)*kk(i5,m)*kk(i5,p)*g3(i4,i5)
       + kk(i4,n)*kk(i5,m)*kk(i6,p)*g1(i4,i6)*g2(i4,i5)
       + kk(i4,n)*kk(i5,p)*kk(i6,m)*g1(i4,i6)*g2(i4,i5)
       + kk(i4,p)*kk(i5,n)*kk(i6,m)*g1(i4,i6)*g2(i4,i5)
       + kk(i4,p)*kk(i5,m)*kk(i6,n)*g1(i4,i6)*g2(i4,i5)
       + kk(i4,m)*kk(i5,p)*kk(i6,n)*g1(i4,i6)*g2(i4,i5)
       + kk(i4,m)*kk(i5,n)*kk(i6,p)*g1(i4,i6)*g2(i4,i5)
       - kk(i4,m)*kk(i5,n)*kk(i6,p)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,m)*kk(i5,p)*kk(i6,n)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,p)*kk(i5,m)*kk(i6,n)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,p)*kk(i5,n)*kk(i6,m)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,n)*kk(i5,p)*kk(i6,m)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,n)*kk(i5,m)*kk(i6,p)*g1(i4,i6)*g2(i5,i6)
       - kk(i4,n)*kk(i5,m)*kk(i6,p)*g3(i4,i5)
       - kk(i4,n)*kk(i5,p)*kk(i6,m)*g3(i4,i5)
       - kk(i4,p)*kk(i5,n)*kk(i6,m)*g3(i4,i5)
       - kk(i4,p)*kk(i5,m)*kk(i6,n)*g3(i4,i5)
       - kk(i4,m)*kk(i5,p)*kk(i6,n)*g3(i4,i5)
       - kk(i4,m)*kk(i5,n)*kk(i6,p)*g3(i4,i5)
       + kk(i4,m)*kk(i5,n)*kk(i6,p)*g3(i5,i6)
       + kk(i4,m)*kk(i5,p)*kk(i6,n)*g3(i5,i6)
       + kk(i4,p)*kk(i5,m)*kk(i6,n)*g3(i5,i6)
       + kk(i4,p)*kk(i5,n)*kk(i6,m)*g3(i5,i6)
       + kk(i4,n)*kk(i5,p)*kk(i6,m)*g3(i5,i6)
       + kk(i4,n)*kk(i5,m)*kk(i6,p)*g3(i5,i6)
       + kk(i4,n)*kk(i5,m)*kk(i7,p)*g1(i4,i7)*g2(i4,i5)
       + kk(i4,n)*kk(i5,p)*kk(i7,m)*g1(i4,i7)*g2(i4,i5)
       + kk(i4,p)*kk(i5,n)*kk(i7,m)*g1(i4,i7)*g2(i4,i5)
       + kk(i4,p)*kk(i5,m)*kk(i7,n)*g1(i4,i7)*g2(i4,i5)
       + kk(i4,m)*kk(i5,p)*kk(i7,n)*g1(i4,i7)*g2(i4,i5)
       + kk(i4,m)*kk(i5,n)*kk(i7,p)*g1(i4,i7)*g2(i4,i5)
       - kk(i4,m)*kk(i5,n)*kk(i7,p)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,m)*kk(i5,p)*kk(i7,n)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,p)*kk(i5,m)*kk(i7,n)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,p)*kk(i5,n)*kk(i7,m)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,n)*kk(i5,p)*kk(i7,m)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,n)*kk(i5,m)*kk(i7,p)*g1(i4,i7)*g2(i5,i7)
       - kk(i4,n)*kk(i5,m)*kk(i7,p)*g3(i4,i5)
       - kk(i4,n)*kk(i5,p)*kk(i7,m)*g3(i4,i5)
       - kk(i4,p)*kk(i5,n)*kk(i7,m)*g3(i4,i5)
       - kk(i4,p)*kk(i5,m)*kk(i7,n)*g3(i4,i5)
       - kk(i4,m)*kk(i5,p)*kk(i7,n)*g3(i4,i5)
       - kk(i4,m)*kk(i5,n)*kk(i7,p)*g3(i4,i5)
       + kk(i4,m)*kk(i5,n)*kk(i7,p)*g3(i5,i7)
       + kk(i4,m)*kk(i5,p)*kk(i7,n)*g3(i5,i7)
       + kk(i4,p)*kk(i5,m)*kk(i7,n)*g3(i5,i7)
       + kk(i4,p)*kk(i5,n)*kk(i7,m)*g3(i5,i7)
       + kk(i4,n)*kk(i5,p)*kk(i7,m)*g3(i5,i7)
       + kk(i4,n)*kk(i5,m)*kk(i7,p)*g3(i5,i7)
       + kk(i4,n)*kk(i5,m)*g2(i4,i5)*ellf(p)
       + kk(i4,n)*kk(i5,p)*g2(i4,i5)*ellf(m)
       + kk(i4,p)*kk(i5,n)*g2(i4,i5)*ellf(m)
       + kk(i4,p)*kk(i5,m)*g2(i4,i5)*ellf(n)
       + kk(i4,m)*kk(i5,p)*g2(i4,i5)*ellf(n)
       + kk(i4,m)*kk(i5,n)*g2(i4,i5)*ellf(p)
       + kk(i4,m)*kk(i6,n)*kk(i6,p)*g3(i4,i6)
       + kk(i4,m)*kk(i6,p)*kk(i6,n)*g3(i4,i6)
       + kk(i4,p)*kk(i6,m)*kk(i6,n)*g3(i4,i6)
       + kk(i4,p)*kk(i6,n)*kk(i6,m)*g3(i4,i6)
       + kk(i4,n)*kk(i6,p)*kk(i6,m)*g3(i4,i6)
       + kk(i4,n)*kk(i6,m)*kk(i6,p)*g3(i4,i6)
       + kk(i4,n)*kk(i6,m)*kk(i7,p)*g1(i4,i7)*g2(i4,i6)
       + kk(i4,n)*kk(i6,p)*kk(i7,m)*g1(i4,i7)*g2(i4,i6)
       + kk(i4,p)*kk(i6,n)*kk(i7,m)*g1(i4,i7)*g2(i4,i6)
       + kk(i4,p)*kk(i6,m)*kk(i7,n)*g1(i4,i7)*g2(i4,i6)
       + kk(i4,m)*kk(i6,p)*kk(i7,n)*g1(i4,i7)*g2(i4,i6)
       + kk(i4,m)*kk(i6,n)*kk(i7,p)*g1(i4,i7)*g2(i4,i6)
       - kk(i4,m)*kk(i6,n)*kk(i7,p)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,m)*kk(i6,p)*kk(i7,n)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,p)*kk(i6,m)*kk(i7,n)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,p)*kk(i6,n)*kk(i7,m)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,n)*kk(i6,p)*kk(i7,m)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,n)*kk(i6,m)*kk(i7,p)*g1(i4,i7)*g2(i6,i7)
       - kk(i4,n)*kk(i6,m)*kk(i7,p)*g3(i4,i6)
       - kk(i4,n)*kk(i6,p)*kk(i7,m)*g3(i4,i6)
       - kk(i4,p)*kk(i6,n)*kk(i7,m)*g3(i4,i6)
       - kk(i4,p)*kk(i6,m)*kk(i7,n)*g3(i4,i6)
       - kk(i4,m)*kk(i6,p)*kk(i7,n)*g3(i4,i6)
       - kk(i4,m)*kk(i6,n)*kk(i7,p)*g3(i4,i6)
       + kk(i4,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       + kk(i4,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       + kk(i4,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       + kk(i4,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       + kk(i4,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       + kk(i4,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i4,n)*kk(i6,m)*g2(i4,i6)*ellf(p)
       + kk(i4,n)*kk(i6,p)*g2(i4,i6)*ellf(m)
       + kk(i4,p)*kk(i6,n)*g2(i4,i6)*ellf(m)
       + kk(i4,p)*kk(i6,m)*g2(i4,i6)*ellf(n)
       + kk(i4,m)*kk(i6,p)*g2(i4,i6)*ellf(n)
       + kk(i4,m)*kk(i6,n)*g2(i4,i6)*ellf(p)
       + kk(i4,m)*kk(i7,n)*kk(i7,p)*g3(i4,i7)
       + kk(i4,m)*kk(i7,p)*kk(i7,n)*g3(i4,i7)
       + kk(i4,p)*kk(i7,m)*kk(i7,n)*g3(i4,i7)
       + kk(i4,p)*kk(i7,n)*kk(i7,m)*g3(i4,i7)
       + kk(i4,n)*kk(i7,p)*kk(i7,m)*g3(i4,i7)
       + kk(i4,n)*kk(i7,m)*kk(i7,p)*g3(i4,i7)
       + kk(i4,n)*kk(i7,m)*g2(i4,i7)*ellf(p)
       + kk(i4,n)*kk(i7,p)*g2(i4,i7)*ellf(m)
       + kk(i4,p)*kk(i7,n)*g2(i4,i7)*ellf(m)
       + kk(i4,p)*kk(i7,m)*g2(i4,i7)*ellf(n)
       + kk(i4,m)*kk(i7,p)*g2(i4,i7)*ellf(n)
       + kk(i4,m)*kk(i7,n)*g2(i4,i7)*ellf(p)
       - kk(i5,m)*kk(i5,n)*kk(i6,p)*g3(i5,i6)
       - kk(i5,m)*kk(i5,p)*kk(i6,n)*g3(i5,i6)
       - kk(i5,p)*kk(i5,m)*kk(i6,n)*g3(i5,i6)
       - kk(i5,p)*kk(i5,n)*kk(i6,m)*g3(i5,i6)
       - kk(i5,n)*kk(i5,p)*kk(i6,m)*g3(i5,i6)
       - kk(i5,n)*kk(i5,m)*kk(i6,p)*g3(i5,i6)
       - kk(i5,n)*kk(i5,m)*kk(i7,p)*g3(i5,i7)
       - kk(i5,n)*kk(i5,p)*kk(i7,m)*g3(i5,i7)
       - kk(i5,p)*kk(i5,n)*kk(i7,m)*g3(i5,i7)
       - kk(i5,p)*kk(i5,m)*kk(i7,n)*g3(i5,i7)
       - kk(i5,m)*kk(i5,p)*kk(i7,n)*g3(i5,i7)
       - kk(i5,m)*kk(i5,n)*kk(i7,p)*g3(i5,i7)
       + kk(i5,m)*kk(i6,n)*kk(i6,p)*g3(i5,i6)
       + kk(i5,m)*kk(i6,p)*kk(i6,n)*g3(i5,i6)
       + kk(i5,p)*kk(i6,m)*kk(i6,n)*g3(i5,i6)
       + kk(i5,p)*kk(i6,n)*kk(i6,m)*g3(i5,i6)
       + kk(i5,n)*kk(i6,p)*kk(i6,m)*g3(i5,i6)
       + kk(i5,n)*kk(i6,m)*kk(i6,p)*g3(i5,i6)
       + kk(i5,n)*kk(i6,m)*kk(i7,p)*g1(i5,i7)*g2(i5,i6)
       + kk(i5,n)*kk(i6,p)*kk(i7,m)*g1(i5,i7)*g2(i5,i6)
       + kk(i5,p)*kk(i6,n)*kk(i7,m)*g1(i5,i7)*g2(i5,i6)
       + kk(i5,p)*kk(i6,m)*kk(i7,n)*g1(i5,i7)*g2(i5,i6)
       + kk(i5,m)*kk(i6,p)*kk(i7,n)*g1(i5,i7)*g2(i5,i6)
       + kk(i5,m)*kk(i6,n)*kk(i7,p)*g1(i5,i7)*g2(i5,i6)
       - kk(i5,m)*kk(i6,n)*kk(i7,p)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,m)*kk(i6,p)*kk(i7,n)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,p)*kk(i6,m)*kk(i7,n)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,p)*kk(i6,n)*kk(i7,m)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,n)*kk(i6,p)*kk(i7,m)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,n)*kk(i6,m)*kk(i7,p)*g1(i5,i7)*g2(i6,i7)
       - kk(i5,n)*kk(i6,m)*kk(i7,p)*g3(i5,i6)
       - kk(i5,n)*kk(i6,p)*kk(i7,m)*g3(i5,i6)
       - kk(i5,p)*kk(i6,n)*kk(i7,m)*g3(i5,i6)
       - kk(i5,p)*kk(i6,m)*kk(i7,n)*g3(i5,i6)
       - kk(i5,m)*kk(i6,p)*kk(i7,n)*g3(i5,i6)
       - kk(i5,m)*kk(i6,n)*kk(i7,p)*g3(i5,i6)
       + kk(i5,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       + kk(i5,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       + kk(i5,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       + kk(i5,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       + kk(i5,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       + kk(i5,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i5,n)*kk(i6,m)*g2(i5,i6)*ellf(p)
       + kk(i5,n)*kk(i6,p)*g2(i5,i6)*ellf(m)
       + kk(i5,p)*kk(i6,n)*g2(i5,i6)*ellf(m)
       + kk(i5,p)*kk(i6,m)*g2(i5,i6)*ellf(n)
       + kk(i5,m)*kk(i6,p)*g2(i5,i6)*ellf(n)
       + kk(i5,m)*kk(i6,n)*g2(i5,i6)*ellf(p)
       + kk(i5,m)*kk(i7,n)*kk(i7,p)*g3(i5,i7)
       + kk(i5,m)*kk(i7,p)*kk(i7,n)*g3(i5,i7)
       + kk(i5,p)*kk(i7,m)*kk(i7,n)*g3(i5,i7)
       + kk(i5,p)*kk(i7,n)*kk(i7,m)*g3(i5,i7)
       + kk(i5,n)*kk(i7,p)*kk(i7,m)*g3(i5,i7)
       + kk(i5,n)*kk(i7,m)*kk(i7,p)*g3(i5,i7)
       + kk(i5,n)*kk(i7,m)*g2(i5,i7)*ellf(p)
       + kk(i5,n)*kk(i7,p)*g2(i5,i7)*ellf(m)
       + kk(i5,p)*kk(i7,n)*g2(i5,i7)*ellf(m)
       + kk(i5,p)*kk(i7,m)*g2(i5,i7)*ellf(n)
       + kk(i5,m)*kk(i7,p)*g2(i5,i7)*ellf(n)
       + kk(i5,m)*kk(i7,n)*g2(i5,i7)*ellf(p)
       - kk(i6,m)*kk(i6,n)*kk(i7,p)*g3(i6,i7)
       - kk(i6,m)*kk(i6,p)*kk(i7,n)*g3(i6,i7)
       - kk(i6,p)*kk(i6,m)*kk(i7,n)*g3(i6,i7)
       - kk(i6,p)*kk(i6,n)*kk(i7,m)*g3(i6,i7)
       - kk(i6,n)*kk(i6,p)*kk(i7,m)*g3(i6,i7)
       - kk(i6,n)*kk(i6,m)*kk(i7,p)*g3(i6,i7)
       + kk(i6,n)*kk(i7,m)*kk(i7,p)*g3(i6,i7)
       + kk(i6,n)*kk(i7,p)*kk(i7,m)*g3(i6,i7)
       + kk(i6,p)*kk(i7,n)*kk(i7,m)*g3(i6,i7)
       + kk(i6,p)*kk(i7,m)*kk(i7,n)*g3(i6,i7)
       + kk(i6,m)*kk(i7,p)*kk(i7,n)*g3(i6,i7)
       + kk(i6,m)*kk(i7,n)*kk(i7,p)*g3(i6,i7)
       + kk(i6,m)*kk(i7,n)*g2(i6,i7)*ellf(p)
       + kk(i6,m)*kk(i7,p)*g2(i6,i7)*ellf(n)
       + kk(i6,p)*kk(i7,m)*g2(i6,i7)*ellf(n)
       + kk(i6,p)*kk(i7,n)*g2(i6,i7)*ellf(m)
       + kk(i6,n)*kk(i7,p)*g2(i6,i7)*ellf(m)
       + kk(i6,n)*kk(i7,m)*g2(i6,i7)*ellf(p)
        ;

** refined 7pt Z functions
       id ZZ(i1?,[p],i2?,[c],i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?,[v],m?) =
       - kk(i2,m)*s(i1,i2)*g1(i1,i2)*g2(i1,i2)
       + 3*kk(i2,m)*s(i1,i2)*g3(i1,i2)
       - kk(i2,m)*dg2(i1,i2)
       - kk(i3,m)*s(i1,i3)*g1(i1,i3)*g2(i1,i3)
       + 3*kk(i3,m)*s(i1,i3)*g3(i1,i3)
       - kk(i3,m)*dg2(i1,i3)
       - kk(i4,m)*s(i1,i4)*g1(i1,i4)*g2(i1,i4)
       + 3*kk(i4,m)*s(i1,i4)*g3(i1,i4)
       - kk(i4,m)*dg2(i1,i4)
       - kk(i5,m)*s(i1,i5)*g1(i1,i5)*g2(i1,i5)
       + 3*kk(i5,m)*s(i1,i5)*g3(i1,i5)
       - kk(i5,m)*dg2(i1,i5)
       - kk(i6,m)*s(i1,i6)*g1(i1,i6)*g2(i1,i6)
       + 3*kk(i6,m)*s(i1,i6)*g3(i1,i6)
       - kk(i6,m)*dg2(i1,i6)
       - kk(i7,m)*s(i1,i7)*g1(i1,i7)*g2(i1,i7)
       + 3*kk(i7,m)*s(i1,i7)*g3(i1,i7)
       - kk(i7,m)*dg2(i1,i7)
      ;

   id ZZ(i1?,[p],i2?,i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?) =
       - s(i1,i2)*g1(i1,i2)*g2(i1,i2)
       + 3*s(i1,i2)*g3(i1,i2)
       + s(i1,i3)*g1(i1,i3)*g2(i1,i3)
       - 3*s(i1,i3)*g3(i1,i3)
       - dg2(i1,i2)
       + dg2(i1,i3)
      ;

   id ZZ(i1?,i2?,[p],i3?,[c],i4?,[c],i5?,[c],i6?,[c],i7?) =
       + s(i1,i2)*g1(i1,i2)*g2(i1,i2)
       - 3*s(i1,i2)*g3(i1,i2)
       + dg2(i1,i2)
      ;

